import jive.javaSpace.*;
import jive.util.*;
import jive.security.*;
import java.security.*;
import java.security.acl.*;
import java.lang.reflect.*;

class Inizia {

	public static void main (String args[]) {

		//creo tre identit: un creatore, uno scrittore, un lettore
	AgentIdentity creator = new AgentIdentity("creator");
	AgentIdentity writer = new AgentIdentity("writer1");
	AgentIdentity reader = new AgentIdentity("reader1");

		//creo tre tuple
	TuplaProva tupla=new TuplaProva(new String("primo"),new Integer(1),new Boolean (true));
	TuplaProva tupla2=new TuplaProva(new String("secondo"),new Integer("0"),new Boolean("true"));
	TuplaProva tupla3=new TuplaProva(new String("altro"),new Integer("1"),new Boolean("true"));
	TuplaProva tuplatempl1= new TuplaProva(null,null,null);

		//variabili di comodo
	int quanteTuple;
	int k;
	int i;
	int numeroTuple;
	int numeroCampi;
	Entry result;
	Entry[] resultArray;
	Class rif;
	Field[] attrib;
	
	Passer passer=new Passer();

	MARS space;

		//crea un metaspace ed un passivespace e li passa al kernel
	PassiveSpace spaziopassivo=new PassiveSpace(creator,passer);
	MetaSpace metaspazio=new MetaSpace(creator,passer);
	SpaceKernel kernel=new SpaceKernel(spaziopassivo,metaspazio, null, null);
		
		//si concede tutti i diritti
	AclImpl acl_base = new AclImpl(creator);
	AclImpl acl_meta = new AclImpl(creator);

		// mi concedo tutti i diritti
	AclEntry acle = new AclEntryImpl(creator);
	acle.addPermission(new PermissionImpl("REACTIVE"));
	acle.addPermission(new PermissionImpl("PASSIVE"));
	acle.addPermission(new PermissionImpl("REMOTE"));
	//acle.addPermission(new PermissionImpl("WRITE"));
	acle.addPermission(new PermissionImpl("TAKE"));
	acle.addPermission(new PermissionImpl("READ"));
	acle.addPermission(new PermissionImpl("PROGRAM"));
	acle.addPermission(new PermissionImpl("CLEAR"));
	try {
		acl_base.addEntry(creator, acle);
	} catch (NotOwnerException e) {
	}


	
	/***************************************************************************
	 *il creator esegue tre write, una read, una readAll ed una take
	 * ed infine una takeAll ma usando direttamente
	 *spaziopassivo, ovvero senza passare attraverso il nucleo
	 *Dopo ogni 
	 *operazione scrive i risultati e controlla il numero di tuple nello spazio
	 ***************************************************************************/

	System.out.println("sono "+creator+" faccio le write");
	spaziopassivo.write(tupla,new Transaction(null),10,creator);
		tupla.showValues();
	spaziopassivo.write(tupla2,new Transaction(null),10,creator);
		tupla2.showValues();
	spaziopassivo.write(tupla3,new Transaction(null),10,creator);
		tupla3.showValues();
	quanteTuple=spaziopassivo.size();
	System.out.println("numero tuple nello spazio passivo: "+quanteTuple);

	
	System.out.println("	faccio la read con il template");
	tuplatempl1.showValues();
	result=spaziopassivo.read(tuplatempl1,new Transaction(null),10000,creator);
	System.out.println("	ho letto la seguente tupla ");

	if (result!=null) {
			//cerchiamo di tradurre
		//rif = ((Object)result).getClass();
		//attrib = rif.getFields();
		//numeroCampi= Array.getLength(attrib);
		result.showValues();
	}

	System.out.println("	faccio la readALL con il template");
	tuplatempl1.showValues();
	resultArray=spaziopassivo.readAll(tuplatempl1,new Transaction(null),10000,creator);
	System.out.println("	ho letto le seguenti tuple");
		
	numeroTuple=Array.getLength(resultArray);
	for(i=1;i<=numeroTuple;i++) {
		resultArray[i-1].showValues();
	}

	quanteTuple=spaziopassivo.size();
	System.out.println("numero tuple nello spazio passivo: "+quanteTuple);

	System.out.println("	faccio la take usando il template");	
	tuplatempl1.showValues();
	result=spaziopassivo.take(tuplatempl1,new Transaction(null),10000,creator);
	System.out.println("	ho preso la seguente tupla");
	result.showValues();

	quanteTuple=spaziopassivo.size();
	System.out.println("numero tuple nello spazio passivo: "+quanteTuple);

	System.out.println("	faccio la takeAll usando il template");	
	tuplatempl1.showValues();
	resultArray=spaziopassivo.takeAll(tuplatempl1,new Transaction(null),10000,creator);
	System.out.println("	ho preso le seguenti tuple");
	

	numeroTuple=Array.getLength(resultArray);
	for(i=1;i<=numeroTuple;i++) {
		resultArray[i-1].showValues();
	}

	quanteTuple=spaziopassivo.size();
	System.out.println("numero tuple: "+quanteTuple);

	}
}
