
import java.lang.reflect.*;
import java.net.*;
import java.io.*;
import jive.javaSpace.*;
import jive.util.*;
import jive.security.*;
import java.security.*;
import java.security.acl.*;



public class MARSServer2{

	int i;
	int numeroTuple;
	Socket socketIn=null;
	Socket socketOut=null;

	String recordIn;
	String recordOut;

		//identit del MARS-server
	AgentIdentity creator = new AgentIdentity("creator");	
	Passer passer=new Passer();
	RThreadManager agentManager=new RThreadManager(passer);
	
		//creazione del kernel (spazio reattivo e passivo)
		//cui passeranno attraverso lettori e scrittori	
		//crea un metaspace ed un passivespace e li passa al kernel
	PassiveSpace passiveSpace=new PassiveSpace(creator,passer);
	MetaSpace metaSpace=new MetaSpace(creator,passer);
	SpaceKernel kernel=new SpaceKernel(passiveSpace,metaSpace, passer, agentManager);

		//alcune azioni sugli spazio:  una sorta di inizializzazione
		//si veda anche il metodo programSpace
	ThreadProva rThread1=new ThreadProva();
	ProtEntry tupla= new ProtEntry(new String("campo_4"),new String("campo_5"));
	ProtEntry tupla2= new ProtEntry(new String("campo_1"),new String("campo_2"));


public void programSpace() {

}


public String readFromPort() {

	String line=null;
	try{
	BufferedReader r=new BufferedReader(new InputStreamReader(socketIn.getInputStream()));
	
	line=r.readLine();
	//System.out.println(line);

		r.close();

	}
	catch (IOException e )
		{System.out.println("IOExc");}
	return line;
}			



public void writeToPort(String record) {

try{
	BufferedWriter w=new BufferedWriter(new OutputStreamWriter(socketOut.getOutputStream()));
	w.write(record,0,record.length());
	w.newLine();
	w.flush();
}
	catch (IOException e )
		{System.out.println("IOExc");}
}		



public void performMARS(String record) 
{

	int numeroCampi=4;	//numero dei campi delle tuple ProtEntry
	String[] field=new String[numeroCampi];
	field[0]="";
	field[1]="";
	field[2]="";
	field[3]="";

			//contatori e variabili di comodo
	int i=0;
	int j=0;
	boolean go_on=true;
	char c;


			//con questo ciclo riempiamo tutti i campi dell'array "field"
			//nel primo c'e' l'agent_id
			//nel secondo l'operation_id
			//gli altri costiuiscono una Entry per MARS

	for (i=0;i<numeroCampi;i++)
	{
		c=record.charAt(j++);
		go_on=true;
		while(go_on) {
			if(c=='$') go_on=false;
			else {
				if(c=='@') {}
				else { 
						//il primo ed il secondo campo del record
						//non vanno scritti nella entry
					field[i]=field[i]+c;		
				}		
				c=record.charAt(j++);
				
			}
			
		}
	}		

		//se uno dei campi "field"  uguale a null, esso non deve essere
		//passato come stinga="null" ma come puntatore --> le righe
		//che seguono operano questa conversione

	for(i=2;i<numeroCampi;i++) {
		if (field[i].compareTo("null")==0)
			field[i]=null;
	}

	ProtEntry entry=new ProtEntry(field[2],field[3]);

		//inizializziamo un agente utilizzando l'identificatore che ci 
		//stato passato all'inizio del record che abbiamo letto dalla
		
	AgentIdentity agent = new AgentIdentity(field[0]);	
	ReactiveThread agentThread=null;

		//a questo punto dobbiamo lanciare un tipo di thread a seconda 
		//dell'operazione richiesta
		//dobbiamo anche concedergli diritti

	AclEntry acle = new AclEntryImpl(agent);
	
	if (field[1].compareTo("READ")==0)	{
		
			ReactionEntry reactionentry = new ReactionEntry(tupla,agent,"read",rThread1);
			metaSpace.write(reactionentry,new Transaction(null),10,creator);

		agentThread = new ThreadProvaR();
		acle.addPermission(new PermissionImpl("READ"));
	}
	else		
		if(field[1].compareTo("WRITE")==0)	{
				ReactionEntry reactionentry2 = new ReactionEntry(tupla,agent,"write",rThread1);
				metaSpace.write(reactionentry2,new Transaction(null),10,creator);
			agentThread = new ThreadProvaW();
			acle.addPermission(new PermissionImpl("WRITE"));
		}
		else 
			if(field[1].compareTo("TAKE")==0) {
				ReactionEntry reactionentry3 = new ReactionEntry(tupla2,agent,"take",rThread1);
				metaSpace.write(reactionentry3,new Transaction(null),10,creator);
				agentThread = new ThreadProvaT();
				acle.addPermission(new PermissionImpl("TAKE"));
			}
			else 
				if (field[1].compareTo("READA")==0)	{
					agentThread = new ThreadProvaRA();
					acle.addPermission(new PermissionImpl("READ"));
				}
				else
					if (field[1].compareTo("TAKEA")==0)	{
						agentThread = new ThreadProvaTA();
						acle.addPermission(new PermissionImpl("TAKE"));
					}
					else
						System.out.println("no valid operation requested!!");
	
	MARS space=kernel.createSpace(agent,"REACTIVE");  
	
		//dobbiamo concedere all'agente i diritti
	acle.addPermission(new PermissionImpl("REACTIVE"));
	try {
		passiveSpace.addEntry(creator, acle);
	} catch (NotOwnerException e) {
	}
	
	agentManager.Launch(agentThread,entry,(Space)space,agent,null,null);
}

/******************************************************************************/

public void mainProc() {

	this.programSpace();

	try{
	ServerSocket socketS=null;

			//inizializziamo la server-socket con la quale leggiamo
			//dall'esterno

	socketS=new ServerSocket(4001);	

			//main loop dell'applicazione

	while(true){
		
			//apriamo la socket che ci collega al portAdm e lanciamo la readFromPort
			//all'interno della quale leggiamo materialmente dalla porta
		
		socketIn=socketS.accept();		
		recordIn=this.readFromPort();
		socketIn.close();
		
	
			//terminata la lettura dalla porta IR, abbiamo una stringa in recordIn
			//tale stringa corrisponde ad un record che contiene l'identificatore di 
			//un agente, l'id dell'operazione che tale agente vuole eseguire sullo 
			//spazio, la tupla/template che serve a tale operazione
			//utilizzando questo record, invochiamo performMARS che costituisce il 
			//cuore di quest server/amministratore
		
		this.performMARS(recordIn);		
		
	}
	}
	catch (IOException e )
		{System.out.println("IOExc marss2");}
	}
	
}