
import java.lang.reflect.*;
import java.net.*;
import java.io.*;
import jive.javaSpace.*;
import jive.util.*;
import jive.security.*;
import java.security.*;
import java.security.acl.*;



public class MARSServer1{


	Socket socketIn=null;
	Socket socketOut=null;
	//Socket s=null;
	String recordIn;
	String recordOut=new String("@ag_id2$op_id2$fld_1$fld_2$");

	AgentIdentity creator = new AgentIdentity("creator");	
	Passer passer=new Passer();
	RThreadManager agentManager=new RThreadManager(passer);

		//crea un metaspace ed un passivespace e li passa al kernel
	PassiveSpace passiveSpace=new PassiveSpace(creator,passer);
	MetaSpace metaSpace=new MetaSpace(creator,passer);
	SpaceKernel kernel=new SpaceKernel(passiveSpace,metaSpace, passer, agentManager);


public String readFromPort() {

	String line=null;
	try{
	BufferedReader r=new BufferedReader(new InputStreamReader(socketIn.getInputStream()));
	
	line=r.readLine();
	System.out.println(line);

		r.close();

	}
	catch (IOException e )
		{System.out.println("IOExc");}
	return line;
}			



public void writeToPort(String record) {

try{
	BufferedWriter w=new BufferedWriter(new OutputStreamWriter(socketOut.getOutputStream()));
	w.write(record,0,record.length());
	w.newLine();
	w.flush();
}
	catch (IOException e )
		{System.out.println("IOExc");}
}		


public ProtEntry performMARS(String record) 
{
	String[] field=new String[4];
	field[0]="";
	field[1]="";
	field[2]="";
	field[3]="";
	int i=0;
	int j=0;
	boolean go_on=true;
	char c;

	for (i=0;i<4;i++){
		c=record.charAt(j++);
		go_on=true;
		while(go_on) {
			if(c=='$') go_on=false;
			else {
				if(c=='@') {}
				else { 
					//il primo ed il secondo campo del record
					//non vanno scritti nella entry
					field[i]=field[i]+c;		
				}		
				c=record.charAt(j++);
				
			}
			
		}

	}		

	ProtEntry entry=new ProtEntry(field[2],field[3]);
		System.out.println("l'agente "+field[0]);
		System.out.println("ha chiesto "+field[1]+" sulla tupla:");
	entry.showValues();

		//inizializziamo un agente utilizzando l'identificatore che ci 
		//stato passato all'inizio del record che abbiamo letto dalla
		
	AgentIdentity agent = new AgentIdentity(field[0]);	
	ReactiveThread agentThread=null;

		//a questo punto dobbiamo lanciare un tipo di thread a seconda 
		//dell'operazione richiesta
		//dobbiamo anche concedergli diritti
	AclEntry acle = new AclEntryImpl(agent);
	if(field[1].compareTo("READ")==0) {
		agentThread = new ThreadProvaR();
		acle.addPermission(new PermissionImpl("READ"));
	}
	else		
		if(field[1].compareTo("WRITE")==0)	{
			agentThread = new ThreadProvaW();
			acle.addPermission(new PermissionImpl("WRITE"));
		}
		else 
			if(field[1].compareTo("TAKE")==0) {
				agentThread = new ThreadProvaT();
				acle.addPermission(new PermissionImpl("TAKE"));
			}
			else System.out.println("no valid operation requested!!");
	
	//ProtEntry reactionpassa=new ProtEntry(null,null);
	MARS space=kernel.createSpace(agent,"REACTIVE");  
			//dobbiamo concedere all'agente i diritti
	acle.addPermission(new PermissionImpl("REACTIVE"));
	try {
		passiveSpace.addEntry(creator, acle);
	} catch (NotOwnerException e) {
	}
	agentManager.Launch(agentThread,entry,(Space)space,agent,null,null);

	return entry;
}

/*
public Entry accessToMARS(ProtEntry provv)
{
Entry provv2;
spaziopassivo.write(provv,new Transaction(null),10,creator);
provv2=spaziopassivo.take(provv,new Transaction(null),10,creator);
System.out.println("ho fatto la take di ");
provv2.showValues();

return provv2;
}
*/
/******************************************************************************/

public void mainProc() {

	try{
	ServerSocket socketS=null;

	
		//creazione del kernel (spazio reattivo e passivo)
		//cui passeranno attraverso lettori e scrittori	
	 //deve poter scrivere su PassiveSpace 
			//mettiamo creator perche' l'agente usa Space dove, a differenza di
			//reactiveSpace, c'e' il controllo

	while(true){
		
			//apriamo la socket che ci collega al portAdm e lanciamo la readFromPort
			//all'interno della quale leggiamo materialmente dalla porta
		
		socketS=new ServerSocket(11111);	
		socketIn=socketS.accept();		
		recordIn=this.readFromPort();
		socketIn.close();
	
			//terminata la lettura dalla porta IR, abbiamo una stringa in recordIn
			//tale stringa corrisponde ad un record che contiene l'identificatore di 
			//un agente, l'id dell'operazione che tale agente vuole eseguire sullo 
			//spazio, la tupla/template che serve a tale operazione
			//utilizzando questo record, invochiamo performMARS che costituisce il 
			//cuore di quest server/amministratore
		
		ProtEntry entryOut=this.performMARS(recordIn);		
		
			//qulasiasi operazione su MARS restituisce una tupla (per il momento!!!)
			//ma poi dovremo prendere in cosiderazione le OPERAZIONI MULTIPLE	
		//entryOut.showValues();
			//this.accessToMARS(entry);		
		/*
		socketOut=new Socket("localhost",4000);	
		this.writeToPort(recordOut);	
		socketOut.close();
		*/
	}
	}
	catch (Exception e )
		{System.out.println("IOExc");}
	}
	
}