package jive.graphics;

/*************************************************************************
 *  Questa classe consente la creazione di una interfaccia per inserire
 *  una reazione nello spazio di reazioni.
 *************************************************************************/

import java.lang.reflect.*;
import java.util.*;
import jive.util.*;
import java.io.*;
import java.awt.*;
import java.awt.event.*;
import java.security.*;
import jive.security.*;
import jive.javaSpace.*;


public class InsertReactionPanel implements ActionListener, TextListener{

  private Principal myId;
  
  Button abut, okbut;
  Choice ch1, ch2,ch3;
  TextField tf;
  Checkbox lbl2;
  TextArea ta;
  MARSInt space;
  Panel IRP;
  
  public InsertReactionPanel(MARSInt sp, Panel irp, Principal id) {
	
	myId = id;
	space = sp;
	IRP = irp;
	
	// define the layout manager
	GridBagLayout grid = new GridBagLayout();
	IRP.setLayout(grid);
	
	
	Label lbl1 = new Label("Reaction type:");
	lbl1.setForeground(Color.black);
	lbl1.setBackground(Color.lightGray);
	lbl1.setFont(new Font("Helvetica", Font.BOLD, 10));
	lbl1.setAlignment(Label.CENTER);
	
	// campo di selezione della reazione
	ch1 = new Choice();
	String[] s = 
	  read_directory("C:/MARS/jive/reactive_class");
	
	// nella casella di selezione visulaizzo tutte le
	// reazioni disponibili nella classe reactive_class.
	if (s != null)
	  for (int i =0; i < Array.getLength(s); i++)
	ch1.addItem(s[i].substring(0, s[i].indexOf(".")));
	
	
	lbl2 = new Checkbox("Agent/Group Identity:", false);
	lbl2.setForeground(Color.black);
	lbl2.setBackground(Color.lightGray);
	lbl2.setFont(new Font("Helvetica", Font.BOLD, 10));
	
	tf = new TextField("", 15);
	
	Label lbl6 = new Label("Member:");
	lbl6.setForeground(Color.black);
	lbl6.setBackground(Color.lightGray);
	lbl6.setFont(new Font("Helvetica", Font.BOLD, 10));
	lbl6.setAlignment(Label.CENTER);
	
	// creo una textarea con 2 righe e 10 colonne
	ta = new TextArea(2, 10);
	ta.addTextListener(this);
	
	Label lbl3 = new Label("Entry Type:");
	lbl3.setForeground(Color.black);
	lbl3.setBackground(Color.lightGray);
	lbl3.setFont(new Font("Helvetica", Font.BOLD, 10));
	lbl3.setAlignment(Label.CENTER);
	
	// campo di selezione del tipo di tupla
	ch2 = new Choice();
	ch2.addItem("null");
	s = read_directory("C:/MARS/jive/tuple_type");
	
	// nella casella di selezione visulaizzo tutte le
	// tuple disponibili nella classe tuple_class.
	if (s != null)
	  for (int i =0; i < Array.getLength(s); i++)
	ch2.addItem(s[i].substring(0, s[i].indexOf(".")));
	
	Label lbl4 = new Label("Operation Type:");
	lbl4.setForeground(Color.black);
	lbl4.setBackground(Color.lightGray);
	lbl4.setFont(new Font("Helvetica", Font.BOLD, 10));
	lbl4.setAlignment(Label.CENTER);
	
	// campo di selezione del tipo di operazione
	ch3 = new Choice();
	
	// nella casella di selezione visualizzo tutte le
	// operazioni possibili.
	String[] op = new String[16];
	op[0] = "readAll_pre";
	op[1] = "readAll_infra";
	op[2] = "readAll_post";
	op[3] = "takeAll_pre";
	op[4] = "takeAll_infra";
	op[5] = "takeAll_post";
	op[6] = "read_pre";
	op[7] = "read_infra";
	op[8] = "read_post";
	op[9] = "take_pre";
	op[10] = "take_infra";
	op[11] = "take_post";
	op[12] = "write_pre";
	op[13] = "write_infra";
	op[14] = "write_post";
	op[15] = "null";
	 
	  for (int i =0; i < Array.getLength(op); i++)
	ch3.addItem(op[i]);
	
	// bottone di OK
	Button okbut = new Button("OK");
	okbut.setForeground(Color.white);
	okbut.setBackground(Color.darkGray);
	okbut.setFont(new Font("Helvetica", Font.PLAIN, 10));
	
	// bottone di annullo della operazione
	/*Button abut = new Button("Cancel");
	   abut.setForeground(Color.white);
	   abut.setBackground(Color.darkGray);
	   abut.setFont(new Font("Helvetica", Font.BOLD, 10));*/
	
	// define the constraints
	GridBagConstraints gc = new GridBagConstraints();
	gc.insets = new Insets(1, 1, 1, 1);
	gc.fill = GridBagConstraints.BOTH;
	gc.weightx = 1.0;
	gc.weighty = 1.0;
	
	gc.gridwidth = GridBagConstraints.RELATIVE;
	grid.setConstraints(lbl1, gc);
	
	gc.gridwidth = GridBagConstraints.REMAINDER;
	grid.setConstraints(ch1, gc);
	IRP.add(lbl1);
	IRP.add(ch1);
	
	gc.fill = GridBagConstraints.BOTH;
	gc.gridwidth = GridBagConstraints.RELATIVE;
	grid.setConstraints(lbl2, gc);
	gc.gridwidth = GridBagConstraints.REMAINDER;
	grid.setConstraints(tf, gc);
	IRP.add(lbl2);
	IRP.add(tf);
	
	gc.fill = GridBagConstraints.BOTH;
	gc.gridwidth = GridBagConstraints.RELATIVE;
	grid.setConstraints(lbl6, gc);
	gc.gridwidth = GridBagConstraints.REMAINDER;
	grid.setConstraints(ta, gc);
	IRP.add(lbl6);
	IRP.add(ta);
	
	gc.fill = GridBagConstraints.BOTH;
	gc.gridwidth = GridBagConstraints.RELATIVE;
	grid.setConstraints(lbl3, gc);
	gc.gridwidth = GridBagConstraints.REMAINDER;
	grid.setConstraints(ch2, gc);
	IRP.add(lbl3);
	IRP.add(ch2);
	
	gc.fill = GridBagConstraints.BOTH;
	gc.gridwidth = GridBagConstraints.RELATIVE;
	grid.setConstraints(lbl3, gc);
	gc.gridwidth = GridBagConstraints.REMAINDER;
	grid.setConstraints(ch2, gc);
	IRP.add(lbl3);
	IRP.add(ch2);
	
	gc.fill = GridBagConstraints.BOTH;
	gc.gridwidth = GridBagConstraints.RELATIVE;
	grid.setConstraints(lbl4, gc);
	gc.gridwidth = GridBagConstraints.REMAINDER;
	grid.setConstraints(ch3, gc);
	IRP.add(lbl4);
	IRP.add(ch3);
	
	gc = new GridBagConstraints();
	gc.weightx = 1.0;
	gc.weighty = 1.0;
	gc.insets = new Insets(1, 1, 1, 1);
	
	gc.fill = GridBagConstraints.BOTH;
	gc.gridwidth = GridBagConstraints.REMAINDER;
	grid.setConstraints(okbut, gc);
	IRP.add(okbut);
	
	/*gc.gridx = GridBagConstraints.RELATIVE;
	  grid.setConstraints(abut, gc);
	  IRP.add(abut);
	  abut.addActionListener(this);*/
	
	// Metto un listener in ascolto sui due bottoni.
	okbut.addActionListener(this);
	
	IRP.setVisible(true);
	IRP.validate();
	IRP.repaint();
  }  
  public void actionPerformed(ActionEvent e) {
	}
  public String[] read_directory(String path) {	
	File f = null;
	try {
	  f = new File(path);
	} catch(NullPointerException ex)
	  { return new String[0]; }
	
	String[] names = f.list(new ExtensionFilter("class"));
	return names;
  }  
  // quando il testo nella textarea cambia verifico che la checkbox
  // sia false (cioe' indichi che l'identita' e di agente)
  public void textValueChanged(TextEvent e) {
	// se l'utente sta introducendo dati e la checkbox e' false
	// la setto a true
	if (!lbl2.getState()) lbl2.setState(true);
  }  
}