package jive.graphics;

/*************************************************************************
 *  Questa classe consente la creazione di una interfaccia per inserire
 *  una reazione nello spazio di reazioni.
 *************************************************************************/

import java.lang.reflect.*;
import java.util.*;
import jive.util.*;
import java.io.*;
import java.awt.*;
import java.awt.event.*;
import java.security.*;
import jive.security.*;
import jive.javaSpace.*;


public class InsertReactionPanel implements ActionListener, TextListener{

  private Principal myId;
  
  Button abut, okbut;
  Choice ch1, ch2,ch3;
  TextField tf;
  Checkbox lbl2;
  TextArea ta;
  MARSInt space;
  Panel IRP;
  private Vector vecField = new Vector();
  private int index1 = 0;
  private int index2 = 0;
  private Vector vecCheckBox = new Vector();
  public InsertReactionPanel(MARSInt sp, Panel irp, Principal id) {
	
	myId = id;
	space = sp;
	IRP = irp;
	
	// define the layout manager
	GridBagLayout grid = new GridBagLayout();
	IRP.setLayout(grid);
	
	
	Label lbl1 = new Label("Reaction type:");
	lbl1.setForeground(Color.black);
	lbl1.setBackground(Color.lightGray);
	lbl1.setFont(new Font("Helvetica", Font.BOLD, 10));
	lbl1.setAlignment(Label.CENTER);
	
	// campo di selezione della reazione
	ch1 = new Choice();
	String[] s = //50
	  read_directory("C:/mars/jive/reactive_class");
	
	// nella casella di selezione visulaizzo tutte le
	// reazioni disponibili nella classe reactive_class.
	if (s != null)
	  for (int i =0; i < Array.getLength(s); i++)
	ch1.addItem(s[i].substring(0, s[i].indexOf(".")));
	
	
	lbl2 = new Checkbox("Agent/Group Identity:", false);
	lbl2.setForeground(Color.black);
	lbl2.setBackground(Color.lightGray);
	lbl2.setFont(new Font("Helvetica", Font.BOLD, 10));
	
	tf = new TextField("", 15);
	
	Label lbl6 = new Label("Member:");
	lbl6.setForeground(Color.black);
	lbl6.setBackground(Color.lightGray);
	lbl6.setFont(new Font("Helvetica", Font.BOLD, 10));
	lbl6.setAlignment(Label.CENTER);
	
	// creo una textarea con 2 righe e 10 colonne
	ta = new TextArea(2, 10);
	ta.addTextListener(this);
	
	Label lbl3 = new Label("Entry Type:");
	lbl3.setForeground(Color.black);
	lbl3.setBackground(Color.lightGray);
	lbl3.setFont(new Font("Helvetica", Font.BOLD, 10));
	lbl3.setAlignment(Label.CENTER);
	
	// campo di selezione del tipo di tupla
	ch2 = new Choice();
	ch2.addItem("null");
	String[] d = 
	read_directory("C:/mars/jive/tuple_type");
	// nella casella di selezione visulaizzo tutte le
	// tuple disponibili nella classe tuple_class.
	if (d != null)
	  for (int i =0; i < Array.getLength(d); i++)
	ch2.addItem(d[i].substring(0, d[i].indexOf(".")));
	
	Label lbl4 = new Label("Operation Type:");
	lbl4.setForeground(Color.black);
	lbl4.setBackground(Color.lightGray);
	lbl4.setFont(new Font("Helvetica", Font.BOLD, 10));
	lbl4.setAlignment(Label.CENTER);
	
	// campo di selezione del tipo di operazione
	ch3 = new Choice();//100
	
	// nella casella di selezione visualizzo tutte le
	// operazioni possibili.
	String[] op = new String[16];
	op[0] = "readAll";
	op[1] = "read";
	op[2] = "readIfExists";
	op[3] = "takeAll";
	op[4] = "take";
	op[5] = "takeIfExists";
	op[6] = "snapshot";
	op[7] = "write";
	op[8] = "notify";
	op[9] = "null";
	 
	  for (int i =0; i < Array.getLength(op); i++)
	ch3.addItem(op[i]);
	
	// bottone di OK
	Button okbut = new Button("OK");
	okbut.setForeground(Color.white);
	okbut.setBackground(Color.darkGray);
	okbut.setFont(new Font("Helvetica", Font.PLAIN, 10));
	
	// bottone di annullo della operazione
	/*Button abut = new Button("Cancel");
	   abut.setForeground(Color.white);
	   abut.setBackground(Color.darkGray);
	   abut.setFont(new Font("Helvetica", Font.BOLD, 10));*/
	
	// define the constraints
	GridBagConstraints gc = new GridBagConstraints();
	gc.insets = new Insets(1, 1, 1, 1);
	gc.fill = GridBagConstraints.BOTH;
	gc.weightx = 1.0;
	gc.weighty = 1.0;
	
	gc.gridwidth = GridBagConstraints.RELATIVE;
	grid.setConstraints(lbl1, gc);
	
	gc.gridwidth = GridBagConstraints.REMAINDER;
	grid.setConstraints(ch1, gc);
	IRP.add(lbl1);
	IRP.add(ch1);
	
	gc.fill = GridBagConstraints.BOTH;
	gc.gridwidth = GridBagConstraints.RELATIVE;
	grid.setConstraints(lbl2, gc);
	gc.gridwidth = GridBagConstraints.REMAINDER;
	grid.setConstraints(tf, gc);//150
	IRP.add(lbl2);
	IRP.add(tf);
	
	gc.fill = GridBagConstraints.BOTH;
	gc.gridwidth = GridBagConstraints.RELATIVE;
	grid.setConstraints(lbl6, gc);
	gc.gridwidth = GridBagConstraints.REMAINDER;
	grid.setConstraints(ta, gc);
	IRP.add(lbl6);
	IRP.add(ta);
	
	gc.fill = GridBagConstraints.BOTH;
	gc.gridwidth = GridBagConstraints.RELATIVE;
	grid.setConstraints(lbl3, gc);
	gc.gridwidth = GridBagConstraints.REMAINDER;
	grid.setConstraints(ch2, gc);
	IRP.add(lbl3);
	IRP.add(ch2);
	
	gc.fill = GridBagConstraints.BOTH;
	gc.gridwidth = GridBagConstraints.RELATIVE;
	grid.setConstraints(lbl3, gc);
	gc.gridwidth = GridBagConstraints.REMAINDER;
	grid.setConstraints(ch2, gc);
	IRP.add(lbl3);
	IRP.add(ch2);
	
	gc.fill = GridBagConstraints.BOTH;
	gc.gridwidth = GridBagConstraints.RELATIVE;
	grid.setConstraints(lbl4, gc);
	gc.gridwidth = GridBagConstraints.REMAINDER;
	grid.setConstraints(ch3, gc);
	IRP.add(lbl4);
	IRP.add(ch3);
	
	gc = new GridBagConstraints();
	gc.weightx = 1.0;
	gc.weighty = 1.0;
	gc.insets = new Insets(1, 1, 1, 1);
	
	gc.fill = GridBagConstraints.BOTH;
	gc.gridwidth = GridBagConstraints.REMAINDER;
	grid.setConstraints(okbut, gc);
	IRP.add(okbut);
	
	/*gc.gridx = GridBagConstraints.RELATIVE;
	  grid.setConstraints(abut, gc);
	  IRP.add(abut);
	  abut.addActionListener(this);*/
	//200
	// Metto un listener in ascolto sui due bottoni.
	okbut.addActionListener(this);
	
	IRP.setVisible(true);
	IRP.validate();
	IRP.repaint();
  }  
  public void actionPerformed(ActionEvent e) {
	
	if (e.getActionCommand() == "OK") {
	  // se la checkbox e' false l'identita' e' di agente
	  
	  // setto l'identita' a "manager" se nessuna identita' e' 
	  // specificata nel textfield viene assegnata questa
	  AgentIdentity I = (AgentIdentity) myId;
	  
	  if ( (tf.getText() != null) &&
	   (!tf.getText().trim().equals("null")) ) {
	// se la checkbox e' true l'idetita' e di gruppo
	if (!lbl2.getState())
	  I = new AgentIdentity(tf.getText());
	else {
	  I = new AgentGroup(tf.getText());
	  String Buffer;	
	  try {
	    String tmp = null;
	    Buffer = ta.getText(); 
	    StringBufferInputStream in =	new 
	      StringBufferInputStream(Buffer);
	    DataInputStream dis = new DataInputStream(in);
	    
	    while((tmp = dis.readLine()) != null) {
	      System.out.println("***  Aggiungo l'agente: "+tmp);
	      AgentIdentity Id = new AgentIdentity(tmp);
	      ((AgentGroup)I).addMember(Id);
	    }
	    System.out.println("***  "+((AgentGroup)I).toString(true));
	  } catch (IOException ex)
	    {System.err.println("error: "+e);}
	  catch (NullPointerException ex)
	    {System.err.println("error: "+e); }	
	}
	  } 
	 
	  // tipo di operazione
	  String O = ch3.getSelectedItem().trim();
	  // se nella string c'e' "null" metto la stringa a null
	  if (O.equals("null") || O.equals("")) O = null;
	  
	  try {//250
	// classe della reazione
	Class C = 
	  Class.forName("jive.reactive_class."+
			ch1.getSelectedItem());
	// classe della entry
	Class E = null;
	if (ch2.getSelectedItem().trim() != "null") {
	  E = Class.forName("jive.tuple_type."+ch2.getSelectedItem());
	  //IRP.removeAll();
	  //new InsertTuplePanel(I, O, C, E, IRP, space);
	}
	else{
Object tr = null;
Object o = null;
tr = RecreateObject(C);
o = RecreateObject(E);
ReactionEntry reaz = new ReactionEntry((Entry)o,I,O,(ReactiveThread)tr);
	  space.write(reaz,null,15000,myId);
	}
	
	  } catch(ClassNotFoundException ex)
	{System.err.println("Error:"+ex);
	/* Si dovra' gestire questo errore in un qualche modo */}
	}//catch (ClassCastException ex)
	//{System.err.println("Error:"+ex);}

	if (e.getActionCommand() == "Cancel") {
	  IRP.setVisible(false);
	}
  }  
  public String[] read_directory(String path) {	
	File f = null;
	try {
	  f = new File(path);
	} catch(NullPointerException ex)
	  { return new String[0]; }
	
	String[] names = f.list(new ExtensionFilter("class"));
	return names;
  }  
  // quando il testo nella textarea cambia verifico che la checkbox
  // sia false (cioe' indichi che l'identita' e di agente)
  public void textValueChanged(TextEvent e) {
	// se l'utente sta introducendo dati e la checkbox e' false
	// la setto a true
	if (!lbl2.getState()) lbl2.setState(true);
  }
/* public AclImpl AssignAcl() {
		
	AgentIdentity first_owner = null;
	Enumeration en = vectOwner.elements();
	//300
	// creo il primo owner, creandolo come agente o come gruppo
	// a seconda  del fatto che la checkbox sia trye o false
	
	ownerPanel op = null;
	if ( ((op =    //jive.graphics.InsertEntryPanel. ownerPanel
	   ((jive.graphics.InsertEntryPanel$ownerPanel)en.nextElement())) != null) &&
	 op.c.getState() )
	  first_owner = new AgentGroup(op.t.getText());
	else 	
	  first_owner =	new AgentIdentity(op.t.getText());
	
	AclImpl ta = new AclImpl(first_owner);
	try {
	  for(;en.hasMoreElements();) {
	op = ((jive.graphics.InsertEntryPanel$ownerPanel)en.nextElement());
	if( op.c.getState() )
	  ((OwnerImpl)ta).addOwner(new AgentGroup( op.t.getText()),
				     first_owner);
	else 
	  ((OwnerImpl)ta).addOwner(new AgentIdentity( op.t.getText()),
				     first_owner);
	  }
	} catch (NotOwnerException e)
	  {System.err.println("error: "+e); return null;}
	
	AclEntryImpl tae = null;
	AgentIdentity ai = null;
	Enumeration em = vectPerm.elements();
	permissionPanel pp = null;
	
	for(;em.hasMoreElements();) {
	  pp = (jive.graphics.InsertEntryPanel$permissionPanel)em.nextElement();
	  if (pp.t.getText() != null) { 
	if (pp.c1.getState()) ai = new AgentGroup(pp.t.getText());
	else ai = new AgentIdentity(pp.t.getText());
	tae = new AclEntryImpl(ai);
	if (pp.c2.getState()) tae.addPermission(new PermissionImpl("READ"));
	if (pp.c3.getState()) tae.addPermission(new PermissionImpl("TAKE"));
	try {
	  // se non e' il proprietario i diritti non vengono immessi
	  // (in realt tale caso non si pu verificare)
	  ta.addEntry(first_owner, tae);
	} catch(NotOwnerException noe)
	  {System.err.println("errore:"+noe);}
	  }
	}
	return ta;
  }  
  private void InsertAcl() {
   
	IEF = new Frame("-- Insert ACL Frame --");
	IEF.setSize(400, 200);
	GridBagConstraints gc = new GridBagConstraints();
	gc.gridwidth = GridBagConstraints.REMAINDER;
	gc.insets = new Insets(1, 1, 1, 1);
	gc.fill = GridBagConstraints.BOTH;
	gc.weightx = 1.0;
	gc.weighty = 1.0;
	IEF.setLayout(gridF);
	
	
	// panel IAP4
	IAP4.setLayout(grid4);
	Label lbl1 = new Label("Owner List");
	lbl1.setForeground(Color.black);
	lbl1.setBackground(Color.lightGray);
	lbl1.setFont(new Font("Helvetica", Font.BOLD, 10));
	lbl1.setAlignment(Label.CENTER);
	
	ch2 = new Choice();
	// j parte da uno siccome almeno un proprietario deve 
	// esserci
	for (int j = 1;j < 20; j++)
	  ch2.addItem((new Integer(j)).toString());
	ch2.addItemListener(this);
	
	GridBagConstraints gc4 = new GridBagConstraints();
	gc4.insets = new Insets(1, 1, 1, 1);
	gc4.fill = GridBagConstraints.BOTH;
	gc4.weightx = 1.0;
	gc4.weighty = 1.0; 
	gc4.gridwidth = GridBagConstraints.RELATIVE;
	grid4.setConstraints(lbl1, gc4);
	IAP4.add(lbl1);
	gc4.gridwidth = GridBagConstraints.REMAINDER;
	grid4.setConstraints(ch2, gc4);
	IAP4.add(ch2);		
	// aggiungo il panel con il campo in cui si specifica il
	// tipo di entry al pannello globale
	gc.weighty = 0.0;
	gridF.setConstraints(IAP4, gc);
	IAP4.setBackground(Color.lightGray);
	IEF.add(IAP4);
	
	IAP5.setLayout(grid5);
	GridBagConstraints gc5 = new GridBagConstraints();
	gc5.insets = new Insets(1, 1, 1, 1);
	gc5.fill = GridBagConstraints.BOTH;
	gc5.weightx = 1.0;
	gc5.weighty = 1.0;
	gc5.gridwidth = GridBagConstraints.RELATIVE;
	
	// almeno un owner deve essere inserito!
	InsertOwner();
	
	// aggiungo il panel al frame
	gc.weighty = 0.0;
	gridF.setConstraints(IAP5, gc);
	IAP5.setBackground(Color.lightGray);
	IEF.add(IAP5);
	
	IAP6.setLayout(grid6);
	GridBagConstraints gc6 = new GridBagConstraints();
				
	Label lbl2 = new Label("Access Control List");
	lbl2.setForeground(Color.black);
	lbl2.setBackground(Color.lightGray);
	lbl2.setFont(new Font("Helvetica", Font.BOLD, 10));
	lbl2.setAlignment(Label.CENTER);
	
	ch3 = new Choice();
	for (int j = 0;j < 20; j++)
	  ch3.addItem((new Integer(j)).toString());
	ch3.addItemListener(this);	
	
	gc6.insets = new Insets(1, 1, 1, 1);
	gc6.fill = GridBagConstraints.BOTH;
	gc6.weightx = 1.0;
	gc6.weighty = 1.0;
	gc6.gridwidth = GridBagConstraints.RELATIVE;
	grid6.setConstraints(lbl2, gc6);
	IAP6.add(lbl2);
	gc6.gridwidth = GridBagConstraints.REMAINDER;
	grid6.setConstraints(ch3, gc6);
	IAP6.add(ch3);		
	// aggiungo il panel al frame
	gc.weighty = 0.0;
	IAP6.setBackground(Color.lightGray);
	gridF.setConstraints(IAP6, gc);
	IEF.add(IAP6);
	
	IAP7.setLayout(grid7);
	gc.weighty = 1.0;
	IAP7.setBackground(Color.lightGray);
	gridF.setConstraints(IAP7, gc);
	IEF.add(IAP7);
	
	// panel IAP8
	// contiene i bottoni di conferma o annullamento
	// bottone di OK
	IAP8.setLayout(grid8);
	okbut1 = new Button("OK");
	okbut1.setForeground(Color.white);
	okbut1.setBackground(Color.darkGray);
	okbut1.setFont(new Font("Helvetica", Font.PLAIN, 10));
	
	cbut1 = new Button("Cancel");
	cbut1.setForeground(Color.white);
	cbut1.setBackground(Color.darkGray);
	cbut1.setFont(new Font("Helvetica", Font.PLAIN, 10));
	
	GridBagConstraints gc8 = new GridBagConstraints();
	gc8.insets = new Insets(1, 1, 1, 1);
	gc8.fill = GridBagConstraints.BOTH;
	gc8.weightx = 1.0;
	gc8.weighty = 1.0;
	gc8.gridwidth = GridBagConstraints.RELATIVE;
	IAP8.setBackground(Color.lightGray);  
	grid8.setConstraints(okbut1, gc8);
	IAP8.add(okbut1);
	
	gc8.gridwidth = GridBagConstraints.REMAINDER;
	gc6.gridwidth = 2;
	grid8.setConstraints(cbut1, gc8);
	IAP8.add(cbut1);
	okbut1.addActionListener(this);
	cbut1.addActionListener(this);
	
	gc.weighty = 0.0;
	gridF.setConstraints(IAP8, gc);
	IEF.add(IAP8);
	
	IEF.setVisible(true);
	IEF.validate();
	IEF.repaint();
  }  
  //lavora sul panel IAP5
  public void InsertOwner(){
	
	Checkbox lbl;
	lbl = new Checkbox("Agent/Group Identity:", false);
	lbl.setForeground(Color.black);
	lbl.setBackground(Color.lightGray);
	lbl.setFont(new Font("Helvetica", Font.BOLD, 10));
	
	TextField tf = new TextField("", 15); //("null", 15);	
	
	GridBagConstraints gc5 = new GridBagConstraints();
	gc5.insets = new Insets(1, 1, 1, 1);
	gc5.fill = GridBagConstraints.BOTH;
	gc5.weightx = 1.0;
	gc5.weighty = 1.0;
	gc5.fill = GridBagConstraints.BOTH;
	gc5.gridwidth = GridBagConstraints.RELATIVE;
	grid5.setConstraints(lbl, gc5);
	
	gc5.gridwidth = GridBagConstraints.REMAINDER;
	grid5.setConstraints(tf, gc5);
	IAP5.add(lbl);
	IAP5.add(tf);
		
	// creo un array di oggetti che in due campi memorizzano
	// la checkbox e il textfield
	ownerPanel o = new ownerPanel();
	o.c = lbl;
	o.t = tf;
	vectOwner.addElement(o);
  }  
  // lavora sul panel IAP7
  private void InsertPermission() {
	
	Checkbox lbl;
	lbl = new Checkbox("Agent/Group Identity:", false);
	lbl.setForeground(Color.black);
	lbl.setBackground(Color.lightGray);
	lbl.setFont(new Font("Helvetica", Font.BOLD, 10));
	
	TextField tf = new TextField("", 15); //("null", 15);	
	
	Checkbox lbl1;
	lbl1 = new Checkbox("read permission", false);
	lbl1.setForeground(Color.black);
	lbl1.setBackground(Color.lightGray);
	lbl1.setFont(new Font("Helvetica", Font.BOLD, 10));
	
	Checkbox lbl2;
	lbl2 = new Checkbox("take permission", false);
	lbl2.setForeground(Color.black);
	lbl2.setBackground(Color.lightGray);
	lbl2.setFont(new Font("Helvetica", Font.BOLD, 10));
	
	GridBagConstraints gc7 = new GridBagConstraints();
	gc7.insets = new Insets(1, 1, 1, 1);
	gc7.weightx = 1.0;
	gc7.weighty = 1.0;
	gc7.fill = GridBagConstraints.BOTH;
	gc7.gridwidth = GridBagConstraints.RELATIVE;
	grid7.setConstraints(lbl, gc7);
	IAP7.add(lbl);
	
	gc7.gridwidth = GridBagConstraints.REMAINDER;
	grid7.setConstraints(tf, gc7);
	IAP7.add(tf);
	
	gc7.gridwidth = GridBagConstraints.RELATIVE;
	grid7.setConstraints(lbl1, gc7);
	IAP7.add(lbl1);
	
	gc7.gridwidth = GridBagConstraints.REMAINDER;
	grid7.setConstraints(lbl2, gc7);
	IAP7.add(lbl2);
	
	// creo un array di oggetti che in due campi memorizzano
	// la checkbox e il textfield
	permissionPanel p = new permissionPanel();
	p.c1 = lbl;
	p.c2 = lbl1;
	p.c3 = lbl2;
	p.t = tf;
	vectPerm.addElement(p);
  }  */
  private boolean isPrimitive(Field F) {
	try { 
	  if ((F.getType()).equals(Class.forName("java.lang.String"))||
	  (F.getType()).equals(Class.forName("java.lang.Boolean"))||
	  (F.getType()).equals(Class.forName("java.lang.Short"))  ||
	  (F.getType()).equals(Class.forName("java.lang.Character"))||
	  (F.getType()).equals(Class.forName("java.lang.Byte"))   ||
	  (F.getType()).equals(Class.forName("java.lang.Integer"))||
	  (F.getType()).equals(Class.forName("java.lang.Long"))   ||
	  (F.getType()).equals(Class.forName("java.lang.Float"))  ||
	  (F.getType()).equals(Class.forName("java.lang.Double")) ||
	  (F.getType()).equals(Class.forName("java.lang.Void"))   ||		
	  (F.getType()).equals(Class.forName("java.io.File"))     ||
	  (F.getType()).equals(Class.forName("java.util.Date")) )
	return true;
	  else return false;
	} catch(ClassNotFoundException e)
	  {System.out.println("Error:"+e); return false;}
  }  
  // quando il manager cambia il tipo della entry gli vengono
  // visualizzati i campi di quella entry
/*  public void itemStateChanged(ItemEvent e) {
	
	if(e.getSource() == ch1) {
	  // classe della entry
	  Class E = null;
	  IAP2.removeAll();
	  System.out.println("L'item selezionato e': "+ch1.getSelectedItem());
	  try {
	if (ch1.getSelectedItem() != null) {
	  E = Class.forName("jive.tuple_type."+ch1.getSelectedItem());
	  PaintTuplePanel(0, E); 			
	}
	  } catch(ClassNotFoundException ex)
	{System.err.println("Error:"+ex);}
	  IEP.validate();
	  IEP.setVisible(true);
	  IEP.repaint();
	}
	
	if(e.getSource() == ch2) {
	  IAP5.removeAll();
	  if (ch2.getSelectedItem() != null) {
	int m = (new Integer(ch2.getSelectedItem())).intValue();
	for (int i = 0; i < m; i++)
	  InsertOwner();
	  }
	  IEF.validate();
	  IEF.setVisible(true);
	  IEF.repaint();
	}
	if(e.getSource() == ch3) {
	  IAP7.removeAll();
	  if (ch3.getSelectedItem() != null) {
	int m = (new Integer(ch3.getSelectedItem())).intValue();
	for (int i = 0; i < m; i++)
	  InsertPermission();
	  }	
	  IEF.validate();
	  IEF.setVisible(true);
	  IEF.repaint();
	}
	
  } */
private Object RecreateObject(Class Eclass) {
	
	Field[] attributes = Eclass.getFields();
	Constructor cons;
	Object o = null;
	
	try {
	  o = Eclass.newInstance();
	  Class[] parameterClass = new Class[1];
	  parameterClass[0] = Class.forName("java.lang.String");
	  
	  for (int k = 0;k < Array.getLength(attributes); k++ ) {
	if ( !isPrimitive(attributes[k]) ) {
	  // controllo la checkbox, ma anche se  true scorro invoco
	  // RecreateObject altrimenti non so di quanto crescere
	  // l'indice, poi per non uso l'oggetto che vuene ritornato
	  Object obj = null;
	  if (!((Checkbox)vecCheckBox.elementAt(index2++)).getState()) {
	    obj = RecreateObject(attributes[k].getType());
	    attributes[k].set(o, obj);
	  } else {
	    obj = RecreateObject(attributes[k].getType());
	    attributes[k].set(o, null);
	  }
	  
	} else {
	  
	  Object obj = null;
	  if(attributes[k].getType().equals(Class.forName("java.lang.Character"))) {
	    if (((TextField)vecField.elementAt(index1)).
		getText().trim().equals("null"))
	      obj = null;
	    else obj = 
		   new Character(((TextField)vecField.
				  elementAt(index1)).getText().trim().charAt(0));
	    index1++;
	  }	
	  else {
	    if (((TextField)vecField.elementAt(index1)).
		getText().trim().equals("null")) obj = null;
	    else {
	      Object[] parameterObject = new Object[1];
	      cons = attributes[k].getType().getConstructor(parameterClass);
	      parameterObject[0] =
		((TextField)vecField.elementAt(index1)).getText().trim();
	      obj = cons.newInstance(parameterObject);
	    }
	    index1++;
	  }
	  
	  attributes[k].set(o, obj);
	}
	  }		
	} catch (IllegalAccessException e) {System.err.println("Error:"+e);}
	catch (InstantiationException e) {System.err.println("Error:"+e);}
	catch (ClassNotFoundException e) {System.err.println("Error:"+e);}
	catch (NoSuchMethodException e) {System.err.println("Error:"+e);}
	catch (InvocationTargetException  e) {System.err.println("Error:"+e);}
	catch (Exception e) {System.err.println("Error:"+e);}
	return o;
  }  
 
  
}