package jive.graphics;

/*************************************************************************
 *  Questa classe permette la creazione di una interfaccia per monitorare
 *  gli agenti attualmente in esecuzione sull'host.
 *************************************************************************/

import java.lang.reflect.*;
import java.util.*;
import jive.util.*;
import java.io.*;
import java.awt.*;
import java.awt.List;
import java.awt.event.*;
import jive.security.*;
import jive.javaSpace.*;

public class ListAgentsPanel extends Thread implements ActionListener { 
  
  private Button dbut, sbut, rbut, mbut;
  private List list;
  private MARSInt space;
  private Panel LAP;
  private boolean modify = true;
  // nome del java2go-alias dell'host locale
  private String servername;
  
  private Hashtable h;
  
  public ListAgentsPanel(MARSInt sp, Panel lep, String ServerName) {
	space = sp;
	LAP = lep;
	servername = ServerName;
	
	// define the layout manager
	GridBagLayout grid = new GridBagLayout();
	LAP.setLayout(grid);
	
	list = new List(8);
	createList();			
	
	Button rbut = new Button("Resume-update");		
	rbut.setForeground(Color.white);	
	rbut.setBackground(Color.black);
	rbut.setFont(new Font("Helvetica", Font.PLAIN, 10));
	
	Button sbut = new Button("Suspend-update");		
	sbut.setForeground(Color.white);	
	sbut.setBackground(Color.black);
	sbut.setFont(new Font("Helvetica", Font.PLAIN, 10));
	
	GridBagConstraints gc = new GridBagConstraints();
	gc.weightx = 1.0;
	gc.weighty = 1.0;
	gc.insets = new Insets(1, 1, 1, 1);
	gc.fill = GridBagConstraints.BOTH;
	gc.gridwidth = GridBagConstraints.REMAINDER;
	grid.setConstraints(list, gc);
	LAP.add(list);
	
	gc = new GridBagConstraints();
	gc.fill = GridBagConstraints.BOTH;
	gc.weightx = 1.0;
	gc.weighty = 0.0;
	gc.insets = new Insets(1, 1, 1, 1);
	
	gc.gridwidth = GridBagConstraints.RELATIVE;
	grid.setConstraints(rbut, gc);
	LAP.add(rbut);
	
	gc.gridwidth = GridBagConstraints.REMAINDER;
	grid.setConstraints(sbut, gc);
	LAP.add(sbut);
	
	// Metto un listener in ascolto sui due bottoni.
	list.addActionListener(this);
	rbut.addActionListener(this);
	sbut.addActionListener(this);
	
	LAP.setVisible(true);
	LAP.validate();
  }  
  public void actionPerformed(ActionEvent e) {
	
	//int index = 0;
	
	if ((e.getActionCommand() == "Resume-update") ) {
	  System.out.println("###  resume command executed!");
	  this.resume();
	}
	if ((e.getActionCommand() == "Suspend-update") ) {
	  System.out.println("###  suspend command executed!");
	  this.suspend();
	}
  }  
  public void createList() {
	System.out.println("***  updating List ...");
	list.removeAll();
   
	h = null;
	// h = ((Hashtable)Realizer.nameSpaceTable.get(servername));
	// se non e' stata memorizzata la Hashtable non fa nulla
	if (h == null) {
	  System.out.println("###  Non c'e' lo spazio dei nomi");
	  return;
	}
	for(Enumeration e = h.keys(); e.hasMoreElements();) {
	  Object Key = e.nextElement();
	  if (((Thread)h.get(Key)).isAlive())
	list.addItem("** agent:"+Key.toString());
	} 
  }  
  public void run() {
	try {
	  while(true) {
	sleep(10000);
	if (modify) createList();
	  }
	} catch(InterruptedException e)
	  {System.err.println("errore: "+e);}
  }  
  public void Visible(boolean b) {
	LAP.setVisible(b);
  }  
}