package jive.graphics;

/*************************************************************************
 *  Questa classe consente la visualizzazione delle entry memorizzate 
 *  nello spazio. 
 *************************************************************************/
import java.lang.reflect.*;
import java.util.*;
import jive.util.*;
import java.io.*;
import java.awt.*;
import java.awt.List;
import java.awt.event.*;
import java.security.*;
import jive.security.*;
import jive.javaSpace.*;
import jive.tuple_type.*;
public class ListEntryPanel extends Thread implements ActionListener { 

  private Principal myId;
  
  private Button dbut, sbut, rbut, mbut;
  private List list;
  private Vector Entry_List;
  private MARSInt space;
  private Panel LEP;
  private boolean modify = true;
  
  public ListEntryPanel(MARSInt sp, Panel lep, Principal id) {
	
	myId = id;
	space = sp;
	LEP = lep;
	
	GridBagLayout grid = new GridBagLayout();
	LEP.setLayout(grid);
	
	Entry_List = new Vector();	
	list = new List(8);
	// leggo le tuple dallo spazio
	createList();			
	
	dbut = new Button("Delete");
	dbut.setForeground(Color.white);
	dbut.setBackground(Color.black);
	dbut.setFont(new Font("Helvetica", Font.PLAIN, 10));
	
	
	Button rbut = new Button("Resume-update");		
	rbut.setForeground(Color.white);	
	rbut.setBackground(Color.black);
	rbut.setFont(new Font("Helvetica", Font.PLAIN, 10));
	
	Button sbut = new Button("Suspend-update");		
	sbut.setForeground(Color.white);	
	sbut.setBackground(Color.black);
	sbut.setFont(new Font("Helvetica", Font.PLAIN, 10));
	
	GridBagConstraints gc = new GridBagConstraints();
	gc.weightx = 1.0;
	gc.weighty = 1.0;
	gc.insets = new Insets(1, 1, 1, 1);
	gc.fill = GridBagConstraints.BOTH;
	gc.gridwidth = GridBagConstraints.REMAINDER;
	grid.setConstraints(list, gc);
	LEP.add(list);
	
	gc = new GridBagConstraints();
	gc.weightx = 1.0;
	gc.weighty = 0.0;
	gc.insets = new Insets(1, 1, 1, 1);
	
	gc.fill = GridBagConstraints.BOTH;
	gc.gridwidth = GridBagConstraints.REMAINDER;
	grid.setConstraints(dbut, gc);
	LEP.add(dbut);
	
	gc.gridwidth = GridBagConstraints.RELATIVE;
	grid.setConstraints(rbut, gc);
	LEP.add(rbut);
	
	gc.gridwidth = GridBagConstraints.REMAINDER;
	grid.setConstraints(sbut, gc);
	LEP.add(sbut);
	
	// Metto un listener in ascolto sui bottoni.
	list.addActionListener(this);
	dbut.addActionListener(this);
	rbut.addActionListener(this);
	sbut.addActionListener(this);
	
	LEP.setVisible(true);
	LEP.validate();
  }  
  public void actionPerformed(ActionEvent e) {
	Entry E;
	int index = 0;
	
	if (e.getSource().equals((Object)list)) {
	  index = list.getSelectedIndex();
	  E = (Entry)Entry_List.elementAt(index);
	  new ShowEntryFrame(E, space);
	}
	if ((e.getActionCommand() == "Delete") ) {
	  if ( (index = list.getSelectedIndex()) >= 0) {
	E = (Entry)Entry_List.elementAt(index);
	System.out.println("removed entry: "+index+"|"+E.toString());
	// estraggo la tupla in modo non bloccante
	Entry r = space.take(E, new Transaction(new Boolean(false)),0,myId);
	if (r != null) list.delItem(index);
	Entry_List.removeElementAt(index);
	
	  }
	}
	if ((e.getActionCommand() == "Resume-update") ) {
	  System.out.println("resume command executed!");
	  this.resume();
	}
	if ((e.getActionCommand() == "Suspend-update") ) {
	  System.out.println("suspend command executed!");
	  this.suspend();
	}
  }  
  public void createList() {
	System.out.println("***  updating List ...");
	Entry_List.removeAllElements();
	list.removeAll();
	System.out.println(space);
	  Entry[] array =space.readAll(null,new Transaction(new Boolean(false)),0, myId);
	
if (array.length != 0){
for(int i = 0; i < array.length; i++) {
	  System.out.println(i);
		System.out.println("**"+array[i].toString());

	  list.addItem("**"+array[i].toString());
	  Entry_List.addElement(array[i]);
        space.expire();

	 } 
	}
else System.out.println("nessuna tupla inserita");
  }  
  public void run() {
	try {
	  while(true) {
	// ogni 10 secondi ricrea la lista
	sleep(10000);
	if (modify) createList();
	  }
	} catch(InterruptedException e)
	  {System.err.println("errore: "+e);}
  }  
  public void Visible(boolean b) {
	LEP.setVisible(b);
  }  
}