package jive.graphics;

/*************************************************************************
 *  Questa classe consente di visualizzare le reazioni memorizzate nel
 *  reaction Space.
 *************************************************************************/

import java.lang.reflect.*;
import java.util.*;
import jive.util.*;
import java.io.*;
import java.awt.*;
import java.awt.List;
import java.awt.event.*;
import jive.security.*;
import java.security.*;
import jive.javaSpace.*;

public class ListNotifyPanel extends Thread implements ActionListener { 

  private Button abut, dbut;
  private List list;
  private Vector Notify_List;
  private MARSInt space;
  private Panel LNP;
  private boolean stop = false;
  private boolean modify = false;

  private Principal myId;
  public ListNotifyPanel(MARSInt sp, Panel lnp,Principal id) {
	myId = id;
	space = sp;
	LNP = lnp;
   
	GridBagLayout grid = new GridBagLayout();
	LNP.setLayout(grid);

	Notify_List = new Vector();	
	list = new List(8);
	// creo la lista leggendo dal NotifyRecord
	createList();			
	
	Button dbut = new Button("Delete");
	dbut.setForeground(Color.white);
	dbut.setBackground(Color.black);
	dbut.setFont(new Font("Helvetica", Font.PLAIN, 10));
	
	
	
	Button sbut = new Button("Stop-update");		
	sbut.setForeground(Color.white);	
	sbut.setBackground(Color.black);
	sbut.setFont(new Font("Helvetica", Font.PLAIN, 10));
	
	Button rbut = new Button("Resume-update");		
	rbut.setForeground(Color.white);	
	rbut.setBackground(Color.black);
	rbut.setFont(new Font("Helvetica", Font.PLAIN, 10));   
	
	
	GridBagConstraints gc = new GridBagConstraints();
	gc.weightx = 1;
	gc.weighty = 1;
	gc.insets = new Insets(1, 1, 1, 1);
	gc.fill = GridBagConstraints.BOTH;
	gc.gridwidth = GridBagConstraints.REMAINDER;
	grid.setConstraints(list, gc);
	LNP.add(list);
	
	gc = new GridBagConstraints();
	gc.weightx = 1.0;
	gc.weighty = 0.0;
	gc.insets = new Insets(1, 1, 1, 1);
	gc.gridwidth = GridBagConstraints.RELATIVE;		
	gc.fill = GridBagConstraints.BOTH;
	
	grid.setConstraints(dbut, gc);
	LNP.add(dbut);
	
	
	
	gc.gridwidth = GridBagConstraints.RELATIVE;
	grid.setConstraints(sbut, gc);
	LNP.add(sbut);
	
	gc.gridwidth = GridBagConstraints.REMAINDER;
	grid.setConstraints(rbut, gc);
	LNP.add(rbut);
	gc.weighty = 1.0;
	
	// Metto un listener in ascolto sui due bottoni.
	list.addActionListener(this);
	dbut.addActionListener(this);
	
	sbut.addActionListener(this);
	rbut.addActionListener(this);
	
	LNP.setVisible(true);
	LNP.validate();
	
  }  
  public void actionPerformed(ActionEvent e) {
	
	NotifyChit E;
	int index = 0;
	
	if (e.getSource().equals((Object)list)) {
	  index = list.getSelectedIndex();
	  E = (NotifyChit)Notify_List.elementAt(index);
	  //new ShowNotifyFrame(E, space);
	}
	if ((e.getActionCommand() == "Delete") ) {
	  if ( (index = list.getSelectedIndex()) >= 0) {
	E = (NotifyChit)Notify_List.elementAt(index);
	//System.out.println("removed entry: "+index+"|"+E.toString());
	
	 space.getNotifyRecord().removeNotify(E, false);// controllare meglio!
	  list.delItem(index);
	Notify_List.removeElementAt(index);
	//} catch(ClassNotFoundException ex)
		//  {System.out.println("error:"+ex);}
	  }
	}
	
	if ((e.getActionCommand() == "Stop-update") ) {
System.out.println("suspend command executed!");
	  this.suspend();
	}
	if ((e.getActionCommand() == "Resume-update") ) {
	System.out.println("resume command executed!");
	  this.resume();
	}
  }  
  public void createList() {
	System.out.println("***  updating List ...");
	Notify_List.removeAllElements();
	list.removeAll();
	Enumeration e = space.getNotifyRecord().entries(space);
for(;e.hasMoreElements();) {
	NotifyChit NC = (NotifyChit)e.nextElement();
	list.addItem("**"+NC.toString());
	Notify_List.addElement(NC);
	}
  }  
  public void run() {
	try {
	  while(true) {
	sleep(10000);
	if (modify) {
	  createList();
	}
	  }
	} catch(InterruptedException e)
	  {System.err.println("errore: "+e);}
  }  
  public void Visible(boolean b) {
	LNP.setVisible(b);
  }  
}