package jive.graphics;

/*************************************************************************
 *  Questa classe consente di visualizzare le reazioni memorizzate nel
 *  reaction Space.
 *************************************************************************/

import java.lang.reflect.*;
import java.util.*;
import jive.util.*;
import java.io.*;
import java.awt.*;
import java.awt.List;
import java.awt.event.*;
import jive.security.*;
import jive.javaSpace.*;

public class ListReactionPanel extends Thread implements ActionListener { 

  private Button abut, dbut, mbut;
  private List list;
  private Vector Reaction_List;
  private MARS space;
  private Panel LRP;
  private boolean stop = false;
  private boolean modify = false;
  private Principal myId;
  public ListReactionPanel(MARS sp, Panel lrp,Principal id) {
	myId = id;
	space = sp;
	LRP = lrp;
   
	GridBagLayout grid = new GridBagLayout();
	LRP.setLayout(grid);

	Reaction_List = new Vector();	
	list = new List(8);
	// creo la lista leggendo dal MetaSpace
	createList();			
	
	Button dbut = new Button("Delete");
	dbut.setForeground(Color.white);
	dbut.setBackground(Color.black);
	dbut.setFont(new Font("Helvetica", Font.PLAIN, 10));
	
	Button mbut = new Button("Modify");		
	mbut.setForeground(Color.white);	
	mbut.setBackground(Color.black);
	mbut.setFont(new Font("Helvetica", Font.PLAIN, 10));
	
	Button sbut = new Button("Stop-update");		
	sbut.setForeground(Color.white);	
	sbut.setBackground(Color.black);
	sbut.setFont(new Font("Helvetica", Font.PLAIN, 10));
	
	Button rbut = new Button("Resume-update");		
	rbut.setForeground(Color.white);	
	rbut.setBackground(Color.black);
	rbut.setFont(new Font("Helvetica", Font.PLAIN, 10));   
	
	
	GridBagConstraints gc = new GridBagConstraints();
	gc.weightx = 1;
	gc.weighty = 1;
	gc.insets = new Insets(1, 1, 1, 1);
	gc.fill = GridBagConstraints.BOTH;
	gc.gridwidth = GridBagConstraints.REMAINDER;
	grid.setConstraints(list, gc);
	LRP.add(list);
	
	gc = new GridBagConstraints();
	gc.weightx = 1.0;
	gc.weighty = 0.0;
	gc.insets = new Insets(1, 1, 1, 1);
	gc.gridwidth = GridBagConstraints.RELATIVE;		
	gc.fill = GridBagConstraints.BOTH;
	
	grid.setConstraints(dbut, gc);
	LRP.add(dbut);
	
	gc.gridwidth = GridBagConstraints.REMAINDER;
	grid.setConstraints(mbut, gc);
	LRP.add(mbut);
	
	gc.gridwidth = GridBagConstraints.RELATIVE;
	grid.setConstraints(sbut, gc);
	LRP.add(sbut);
	
	gc.gridwidth = GridBagConstraints.REMAINDER;
	grid.setConstraints(rbut, gc);
	LRP.add(rbut);
	gc.weighty = 1.0;
	
	// Metto un listener in ascolto sui due bottoni.
	list.addActionListener(this);
	dbut.addActionListener(this);
	mbut.addActionListener(this);
	sbut.addActionListener(this);
	rbut.addActionListener(this);
	
	LRP.setVisible(true);
	LRP.validate();
	
  }  
  public void actionPerformed(ActionEvent e) {
	
	ReactionEntry E;
	int index = 0;
	
	if (e.getSource().equals((Object)list)) {
	  index = list.getSelectedIndex();
	  E = (ReactionEntry)Reaction_List.elementAt(index);
	  new ShowReactionFrame(E, space);
	}
	if ((e.getActionCommand() == "Delete") ) {
	  if ( (index = list.getSelectedIndex()) >= 0) {
	E = (ReactionEntry)Reaction_List.elementAt(index);
	System.out.println("removed entry: "+index+"|"+E.toString());
	//try {
	 Entry r = space.take(E, new Transaction(new Boolean(false)),
			       myId);
	  if (r!= null) list.delItem(index);
	Reaction_List.removeElementAt(index);
	//} catch(ClassNotFoundException ex)
		//  {System.out.println("error:"+ex);}
	  }
	}
	
	if ((e.getActionCommand() == "Stop-update") ) {
System.out.println("suspend command executed!");
	  this.suspend();
	}
	if ((e.getActionCommand() == "Resume-update") ) {
	System.out.println("resume command executed!");
	  this.resume();
	}
  }  
  public void createList() {
	System.out.println("***  updating List ...");
	Reaction_List.removeAllElements();
	list.removeAll();
	System.out.println(space);
	Entry[] array = space.readAll(null, new Transaction(new Boolean(false)), myId);
	System.out.println(array[i]);
	  list.addItem("**"+array[i].toString());
	  Reaction_List.addElement(array[i]);
	}
  }  
  public void run() {
	try {
	  while(true) {
	sleep(10000);
	if (modify) {
	  createList();
	}
	  }
	} catch(InterruptedException e)
	  {System.err.println("errore: "+e);}
  }  
  public void Visible(boolean b) {
	LRP.setVisible(b);
  }  
}