package jive.graphics;

/*************************************************************************
 *  Questa classe crea il menu principale e crea gli altri Panel e gli
 *  altri Frame.
 *************************************************************************/

import java.util.*;
import jive.util.*;
import java.io.*;
import java.awt.*;
import java.awt.event.*;
import jive.security.*;
import jive.javaSpace.*;
//import jive.security.AccessController;

public class MARSmonitor implements ActionListener {
	
  private SpaceIdentity myId;
  
  private Frame TopWindow;
  private MenuBar Bar = new MenuBar();
  private Panel panel = new Panel();
  private ListReactionPanel LRP;
  private InsertEntryPanel IEP;
  private ListEntryPanel LEP;
  private ListNotifyPanel LNP;
  private ListNotifyPanel LNRP;
  private MenuItem m11;
  private MenuItem m21;
  private MenuItem m22;
  private MenuItem m31;
  private MenuItem m32;
  private MenuItem m33;
  private MenuItem m41;
  private MenuItem m42;
  private MenuItem m43;
  // l'intero ci indica la finestra attiva in un certo momento
  private int window = 0;
  private Passer pin;
  private MARSInt space;
  private String siteName;
  private int iport, sport;
  private Vector StatusVector = new Vector();
  private MARSInt metaspace;
public MARSmonitor(SpaceIdentity id, Passer p, SpaceKernel sp) {
	try { //AccessController.beginPrivileged(); //molto pericoloso!!

		myId = id;
		pin = p;
		siteName = myId.getName();
		iport = myId.classport();
		sport = myId.agentport();
		space = sp.passive;

		metaspace = sp.meta;
		TopWindow = new Frame("-- " + siteName + " MARS Monitor --");
		Menu m1 = new Menu("Exit", true);
		m11 = new MenuItem("Exit");
		m1.add(m11);
		m11.addActionListener(this);
		// java2go?!?!	
		Menu m2 = new Menu("jive", true);
		m21 = new MenuItem("StatusPanel");
		m22 = new MenuItem("Agents");
		m2.add(m21);
		m2.add(m22);
		m21.addActionListener(this);
		m22.addActionListener(this);
		Menu m3 = new Menu("MetaSpace", true);
		m31 = new MenuItem("Insert");
		m32 = new MenuItem("List");
		m33 = new MenuItem("Notify");
		m3.add(m31);
		m3.add(m32);
		m3.add(m33);
		m31.addActionListener(this);
		m32.addActionListener(this);
		m33.addActionListener(this);
		Menu m4 = new Menu("Space", true);
		m41 = new MenuItem("Insert");
		m42 = new MenuItem("List");
		m43 = new MenuItem("Notify");
		m4.add(m41);
		m4.add(m42);
		m4.add(m43);
		m41.addActionListener(this);
		m42.addActionListener(this);
		m43.addActionListener(this);
		Bar.add(m1);
		Bar.add(m2);
		Bar.add(m3);
		Bar.add(m4);
		TopWindow.setMenuBar(Bar);
		TopWindow.add(panel);
		TopWindow.setSize(400, 200);
		TopWindow.setVisible(true);
		window = 1;
		panel.removeAll();
		StatusPanel SP = new StatusPanel(siteName, iport, sport, panel, pin, StatusVector);
		SP.start();
	} finally {
		//AccessController.endPrivileged(); 
	}
}
  public void actionPerformed(ActionEvent e) {
	
	// arresto l'esecuzione dei thread delle finestre se
	// non sono piu' attive.
	if ((window == 4) && (LRP != null)) LRP.stop();
	if ((window == 6) && (LEP != null)) LEP.stop();
	//if ((window == 2) && (LNP != null)) LAP.stop();
	if ((window == 7) && (LNP != null)) LNP.stop();
	if ((window == 8) && (LNRP != null)) LNRP.stop();
	if (e.getActionCommand() == "Exit") {
	  System.exit(0);
	}
	if (e.getActionCommand() == "StatusPanel") {
	  window = 1;
	  panel.removeAll();
			
	  
	  StatusPanel  SP =
	new StatusPanel (siteName, iport, sport, 
			    panel, pin, StatusVector);
	  SP.start();
	}
	/*if (e.getSource() == m22) {
	  window = 2;
	  panel.removeAll();
	  LNP = new ListNotifyPanel(space, panel, myId);
	  LNP.start();
	}
*/
	if (e.getSource() == m31) {
	  window = 3;
	  panel.removeAll();
	  new InsertReactionPanel(metaspace, panel, myId);
	}
	if (e.getSource() == m32) {
	  window = 4;
	  panel.removeAll();
	  LRP = new ListReactionPanel(metaspace, panel,myId);
	  LRP.start();
	}	
	if (e.getSource() == m33) {
	  window = 8;
	  panel.removeAll();
	  LNRP = new ListNotifyPanel(metaspace, panel, myId);
	  LNRP.start();
	}			
	if (e.getSource() == m41) {
	  window = 5;
	  panel.removeAll();
	  IEP = new InsertEntryPanel(space, panel, myId);
	}
	if (e.getSource() == m42) {
	  window = 6;
	  panel.removeAll();
	  LEP = new ListEntryPanel(space, panel, myId);

	  LEP.start();
	}
if (e.getSource() == m43) {
	  window = 7;
	  panel.removeAll();
	  LNP = new ListNotifyPanel(space, panel, myId);

	  LNP.start();

  }  
}
}