package jive.graphics;

/*************************************************************************
 *  Questa classe consente di modificare una reazione gia' inserita nello 
 *  spazio di reazioni.
 *************************************************************************/
import java.lang.reflect.*;
import java.util.*;
import jive.util.*;
import java.io.*;
import java.awt.*;
import java.awt.event.*;
import jive.security.*;
import jive.javaSpace.*;

public class ModifyReactionFrame implements ActionListener, TextListener {

  private Button okbut;
  private Choice ch1, ch2,ch3;
  private Checkbox lbl2;
  private TextField tf;
  private TextArea ta;
  private Space space;
  private Frame MRF = new Frame("--Modify Reaction Frame--");
  private Panel MRP1 = new Panel();
  private Panel MRP2 = new Panel();
  private Panel MRP3 = new Panel();
  // reaction entry vecchia
  private ReactionEntry RE;
  
  // reaction entry modificata
  private ReactionEntry NRE;
  
  // due indici necessari al metodo recreateObject
  private int index1, index2; 

  private Field[] attributes;
  // vecLabel e' il vettore che contiene tutte le label del panel
  private Vector vecLabel = new Vector();
  // vecField e' il vettore che contiene tutti i TextField  del Panel e
  // vecCheckBox contiene le checkbox
  private Vector vecField = new Vector();
  private Vector vecCheckBox = new Vector();
  private GridBagLayout grid = new GridBagLayout();	
  private GridBagLayout gridT = new GridBagLayout();
  private GridBagLayout gridR = new GridBagLayout();
  
  public ModifyReactionFrame(ReactionEntry re, Space sp) {
	
	RE = re; space = sp;
	MRF.setLayout(new BorderLayout());
	MRF.setSize(400,300);	
	MRP2.setLayout(gridT);
	MRP2.setBackground(Color.lightGray);
	
	MRP3.setLayout(grid);
	GridBagConstraints gc = new GridBagConstraints();
	gc.weightx = 1.0;
	gc.weighty = 1.0;
	gc.insets = new Insets(1, 1, 1, 1);
	gc.fill = GridBagConstraints.BOTH;
	gc.gridwidth = GridBagConstraints.RELATIVE;
	
	
	// bottone di OK
	Button okbut = new Button("OK");
	okbut.setForeground(Color.white);
	okbut.setBackground(Color.darkGray);
	okbut.setFont(new Font("Helvetica", Font.PLAIN, 10));
	grid.setConstraints(okbut, gc);
	MRP3.add(okbut);
		
	// bottone di Cancel
	Button cbut = new Button("Cancel");
	cbut.setForeground(Color.white);
	cbut.setBackground(Color.darkGray);
	cbut.setFont(new Font("Helvetica", Font.PLAIN, 10));		
	
	grid.setConstraints(cbut, gc);
	MRP3.add(cbut);
	
	// Metto un listener in ascolto sui  bottoni.
	okbut.addActionListener(this);
	cbut.addActionListener(this);
	
	MRF.add("North", MRP1);
	MRF.add("Center", MRP2);
	MRF.add("South", MRP3);
	
	// questo metodo non fa altro che visualizzare
	// la tupla e ritornarne un'altra se viene modificata
	// in questo caso rendo il pannello non modificabile
	if (RE.getEntry() != null) 
	  PaintTuplePanel( 0, RE.getEntry().entrySpecial().getClass(),
		       RE.getEntry().entry());
	PaintReactionPanel();		
	
	MRF.setVisible(true);	
	MRF.validate();
	MRF.repaint();
  }  
  public void actionPerformed(ActionEvent e) {
	
	if (e.getActionCommand() == "OK") {
	  // identita' di agente
	  AgentIdentity I = null;
	  if (!tf.getText().trim().equals("null")) {
	if (! lbl2.getState())	
	  // e' un agente
	  I = new AgentIdentity(tf.getText());
	else {
	  // e' un gruppo
	  I = new AgentGroup(tf.getText());
	  String Buffer;	
	  try {
	    Buffer = ta.getText(); 
	    String tmp = null;
	    StringBufferInputStream in =	new 
	      StringBufferInputStream(Buffer);
	    DataInputStream dis = new DataInputStream(in);
	    
	    while((tmp = dis.readLine()) != null) {
	      AgentIdentity Id = new AgentIdentity(tmp);
	      ((AgentGroup)I).addMember(Id);
	    }
	  }  catch (IOException ex)
	    {System.err.println("error: "+e);}
	  catch (NullPointerException ex)
	    {System.err.println("error: "+e); }	
	}
	  } 	
	  // tipo di operazione
	  String O = ch3.getSelectedItem();
	  try {
	// classe della reazione
	Class C = 
	  Class.forName("jive.reactive_class."+
			ch1.getSelectedItem());
	// classe della entry
	
	Class E = null;
	Object o = null;
	// se l'entry e' diversa da null assegno la sua classe
	// ad E e ripristino l'oggetto
	if (RE.getEntry() != null) {
	  //azzero le due variabili globali
	  index1 = 0;
		  index2 = 0;
	  // viene usato entrySpecial() siccome la classe corrente
	  // non ha un ClassLoader dell'MCS associato, quindi e' 
	  // necessario usare quello dell'agente che ha lasciato li'
	  // la tupla
	  E = RE.getEntry().entrySpecial().getClass();
	  
	  // creo un istanza della entry con quei valori dei 
	  // campi
	  o = RecreateObject(E);
	  
	  // cancello la Reaction entry vecchia
	  space.deleteReaction(RE.getEntry().entry(), RE.getOperation(),
			       RE.getIdentity());
	  // inserisco la nuova Reaction Entry
	  space.createReaction(((Entry)o), O, I, C);
	  objectPrinter.Printer(o, 0);	
	}
	else {
	  // cancello la Reaction entry vecchia
	  space.deleteReaction(RE.getEntry().entry(), RE.getOperation(),
			       RE.getIdentity());
	  // inserisco la nuova Reaction Entry
	  space.createReaction(null, O, I, C);
	}	
	
	  } catch(ClassNotFoundException ex)
	{System.err.println("Error:"+ex);}		
	  MRF.setVisible(false);
	}
	if (e.getActionCommand() == "Cancel") {
	  MRF.setVisible(false);	
	}
  }  
  private boolean isPrimitive(Field F) {
	try { 
	  if ((F.getType()).equals(Class.forName("java.lang.String"))||
	  (F.getType()).equals(Class.forName("java.lang.Boolean"))||
	  (F.getType()).equals(Class.forName("java.lang.Short"))  ||
	  (F.getType()).equals(Class.forName("java.lang.Character"))||
	  (F.getType()).equals(Class.forName("java.lang.Byte"))   ||
	  (F.getType()).equals(Class.forName("java.lang.Integer"))||
	  (F.getType()).equals(Class.forName("java.lang.Long"))   ||
	  (F.getType()).equals(Class.forName("java.lang.Float"))  ||
	  (F.getType()).equals(Class.forName("java.lang.Double")) ||
	  (F.getType()).equals(Class.forName("java.lang.Void"))   ||	
	  (F.getType()).equals(Class.forName("java.io.File"))     ||
		  (F.getType()).equals(Class.forName("java.util.Date"))   )		
	return true;
	  else return false;
	} catch(ClassNotFoundException e)
	  {System.out.println("Error:"+e); return false;}
  }  
  public void PaintReactionPanel(){
	
	MRP1.setLayout(gridR);
	Label lbl1 = new Label("Reaction type:");
	lbl1.setForeground(Color.black);
	lbl1.setBackground(Color.lightGray);
	lbl1.setFont(new Font("Helvetica", Font.BOLD, 10));
	lbl1.setAlignment(Label.CENTER);
	
	// campo di selezione della reazione metto come default
	// la classe correntemente associata alla reazione
	ch1 = new Choice();
	String REC = RE.getReaction().getClass().toString();
	ch1.addItem(REC.substring(REC.lastIndexOf(".")+1));
	
	String[] s = 
	  read_directory(System.getProperty("C:/jive/reactive_class"));
	
	// nella casella di selezione visualizzo anche tutte le
	// reazioni disponibili nella classe reactive_class.
	if (s != null)
	  for (int i =0; i < Array.getLength(s); i++)
	ch1.addItem(s[i].substring(0, s[i].indexOf(".")));
	
	lbl2 = null;
	if (RE.getIdentity() instanceof AgentGroup)
	  lbl2 = new Checkbox("Agent/Group Identity:", true);
	else 	lbl2 = new Checkbox("Agent/Group Identity:", false);
	lbl2.setForeground(Color.black);
	lbl2.setBackground(Color.lightGray);
	lbl2.setFont(new Font("Helvetica", Font.BOLD, 10));
	
	if (RE.getIdentity() == null) 
	  tf = new TextField("null", 15);
	else tf = new TextField(RE.getIdentity().getName(), 15);
	
	Label lbl6 = new Label("Member:");
	lbl6.setForeground(Color.black);
	lbl6.setBackground(Color.lightGray);
	lbl6.setFont(new Font("Helvetica", Font.BOLD, 10));
	lbl6.setAlignment(Label.CENTER);
	
	// creo una textarea con 2 righe e 10 colonne
	ta = new TextArea(2, 10);
	if (RE.getIdentity() instanceof AgentGroup) {
	  String buffer = "";
	  Enumeration en = ((AgentGroup)RE.getIdentity()).members();
	  for(;en.hasMoreElements();) 
	buffer+="\n"+en.nextElement().toString();
	  ta.setText(buffer);
	}
	ta.addTextListener(this);
	
	Label lbl3 = new Label("Entry Type:");
	lbl3.setForeground(Color.black);
	lbl3.setBackground(Color.lightGray);
	lbl3.setFont(new Font("Helvetica", Font.BOLD, 10));
	lbl3.setAlignment(Label.CENTER);
	
	
	// campo di selezione del tipo di tupla
	// N.B.: nella modifica non consento di cambiare la classe
	// del campo entry della ReactionEntry ma solo i valori degli 
	// attributi
	ch2 = new Choice();
	String EC = "null";
	if (RE.getEntry() != null) {
	  EC = RE.getEntry().entrySpecial().getClass().toString();
	  ch2.addItem(EC.substring(EC.lastIndexOf(".")+1));
	} else ch2.addItem(EC);
	
	
	Label lbl4 = new Label("Operation Type:");
	lbl4.setForeground(Color.black);
	lbl4.setBackground(Color.lightGray);
	lbl4.setFont(new Font("Helvetica", Font.BOLD, 10));
	lbl4.setAlignment(Label.CENTER);
	
	// campo di selezione del tipo di operazione
	ch3 = new Choice();
	ch3.addItem(RE.getOperation());
	
	// nella casella di selezione visualizzo tutte le
	// operazioni possibili.
	String[] op = new String[16];
	op[0] = "readAll_pre";
	op[1] = "readAll_infra";
	op[2] = "readAll_post";
	op[3] = "takeAll_pre";
	op[4] = "takeAll_infra";
	op[5] = "takeAll_post";
	op[6] = "read_pre";
	op[7] = "read_infra";
	op[8] = "read_post";
	op[9] = "take_pre";
	op[10] = "take_infra";
	op[11] = "take_post";
	op[12] = "write_pre";
	op[13] = "write_infra";
	op[14] = "write_post";
	op[15] = "null";
	
	  for (int i =0; i < Array.getLength(op); i++)
	ch3.addItem(op[i]);
	
	GridBagConstraints gc = new GridBagConstraints();
	gc.insets = new Insets(1, 1, 1, 1);
	gc.fill = GridBagConstraints.BOTH;
	gc.weightx = 1.0;
	gc.weighty = 1.0;
	
	gc.gridwidth = GridBagConstraints.RELATIVE;
	gridR.setConstraints(lbl1, gc);
	
	gc.gridwidth = GridBagConstraints.REMAINDER;
	gridR.setConstraints(ch1, gc);
	MRP1.add(lbl1);
	MRP1.add(ch1);
	
	gc.fill = GridBagConstraints.BOTH;
	gc.gridwidth = GridBagConstraints.RELATIVE;
	gridR.setConstraints(lbl2, gc);
	gc.gridwidth = GridBagConstraints.REMAINDER;
	gridR.setConstraints(tf, gc);
	MRP1.add(lbl2);
	MRP1.add(tf);

	gc.fill = GridBagConstraints.BOTH;
	gc.gridwidth = GridBagConstraints.RELATIVE;
	gridR.setConstraints(lbl6, gc);
	gc.gridwidth = GridBagConstraints.RELATIVE;
	gridR.setConstraints(ta, gc);
	MRP1.add(lbl6);
	MRP1.add(ta);
						
	gc.fill = GridBagConstraints.BOTH;
	gc.gridwidth = GridBagConstraints.RELATIVE;
	gridR.setConstraints(lbl3, gc);
	gc.gridwidth = GridBagConstraints.REMAINDER;
	gridR.setConstraints(ch2, gc);
	MRP1.add(lbl3);
	MRP1.add(ch2);
	
	gc.fill = GridBagConstraints.BOTH;
	gc.gridwidth = GridBagConstraints.RELATIVE;
	gridR.setConstraints(lbl4, gc);
	gc.gridwidth = GridBagConstraints.REMAINDER;
	gridR.setConstraints(ch3, gc);
	MRP1.add(lbl4);
	MRP1.add(ch3);
	
  
	MRP1.setVisible(true);
	MRP1.validate();
	MRP1.repaint();
  }  
  private void PaintTuplePanel(int level, Class Eclass, Object E) {
	
	String type = null;
	String prefix = null;
	String strLabel = null;
	Label label;
	GridBagConstraints gc;
	Field[] attributes = Eclass.getFields();
	
	for (int i = 0; i < Array.getLength(attributes); i++) {
	  System.out.println("Livello: "+level+" Passo: "+i);
	  // se il campo non e' primitivo il metodo si richiama
	  if ( !isPrimitive(attributes[i]) ) {
	System.out.println("Livello: "+level+" Passo: "+i+ 
			   " campo "+attributes[i].getName()+" non primitivo!");
	
	try {
	  gc = new GridBagConstraints();
	  gc.weightx = 1.0;
	  gc.weighty = 1.0;
	  gc.insets = new Insets(1, 1, 1, 1);
	  gc.fill = GridBagConstraints.NONE;
	  gc.anchor = GridBagConstraints.WEST;	 
	  
	  prefix = "    ";
	  for(int m = 0; m < level; m++)
	    prefix = prefix + "-------";
	  
	  
	  type = attributes[i].getType().toString();
	  strLabel = prefix+attributes[i].getName().trim()+"("+
	    type.substring(type.lastIndexOf(".")+1)+")";
	  label = new Label(strLabel);
	  // aggiungo la label all'array
	  vecLabel.addElement(label);
	  
	  gc.gridwidth = GridBagConstraints.RELATIVE;
	  gc.weightx = 1.0;		
	  gc.weighty = 1.0;
	  gridT.setConstraints(label, gc);
	  
	  label.setForeground(Color.black);
	  label.setBackground(Color.lightGray); 
	  label.setFont(new Font("Helvetica", Font.BOLD, 10));
	  label.setAlignment(Label.LEFT);		
	  MRP2.add(label);
	  
	  // con questa checkBox specifico se il campo di classe
	  // non primitiva e' un null reference o c'e' una istanza 
	  Checkbox cb = null;
	  if (attributes[i].get((Object)E) == null) 
	    cb = new Checkbox("Field null", true);
	  else 	cb = new Checkbox("Field null", false);
	  
	  vecCheckBox.addElement(cb);
	  gc.anchor = GridBagConstraints.WEST;
	  gc.fill = GridBagConstraints.NONE;
	  gc.gridwidth = GridBagConstraints.REMAINDER;
	  gridT.setConstraints(cb, gc);
	  MRP2.add(cb);
	  
	  PaintTuplePanel((level+1), attributes[i].getType(),
			  attributes[i].get((Object)E));
	} catch(IllegalAccessException ex)
	  {System.out.println("errore:"+ex);}
	  }			
	  else {
	System.out.println("Livello: "+level+" Passo: "+i+ 
			   " campo "+attributes[i].getName()+"primitivo!");
	
	gc = new GridBagConstraints();
	gc.weightx = 1.0;
	gc.weighty = 1.0;
	gc.insets = new Insets(1, 1, 1, 1);
	gc.fill = GridBagConstraints.NONE;
	gc.anchor = GridBagConstraints.WEST;	 
	
	prefix = "    ";
	for (int m = 0; m < level; m++)
	  prefix = prefix + "-------";
	
	type = attributes[i].getType().toString();
	strLabel = prefix+attributes[i].getName().trim()+"("+
	  type.substring(type.lastIndexOf(".")+1)+")";
	
	System.out.println(strLabel);
	
	label = new Label(strLabel);
	// aggiungo la label all'array
	vecLabel.addElement(label);
	gc.gridwidth = GridBagConstraints.RELATIVE;
	gridT.setConstraints(label, gc);
	
	label.setForeground(Color.black);
	label.setBackground(Color.lightGray); 
	label.setFont(new Font("Helvetica", Font.BOLD, 10));
	label.setAlignment(Label.LEFT);		
	MRP2.add(label);
	
	TextField tf = null;
	try {		
	  // se E e' null viene lanciata una NullPointerException
	  // e nel catch si crea una label vuota.
	  if (attributes[i].get((Object)E) != null)
	    tf = 
	      new TextField(attributes[i].get((Object)E).toString(),
			    10);
	  // scrivo null quando e' nullo il campo
	  else tf = new TextField("null", 10);
	  
	} catch(IllegalAccessException ex)
	  {System.out.println("errore:"+ex);}
	catch(NullPointerException ex)
	  // non metto niente nel textfield quando l'oggetto
	  // a cui appartiene l'attributo e'  nullo
	  {tf = new TextField("", 10);
	  System.out.println("errore:"+ex);}
	
	// aggiungo il TextField all'array
	vecField.addElement(tf);
	gc.fill = GridBagConstraints.NONE;
	gc.anchor = GridBagConstraints.EAST;
	
	gc.gridwidth = GridBagConstraints.REMAINDER;
	gridT.setConstraints(tf, gc);
	MRP2.add(tf);	
	  }
	}
  }  
  public String[] read_directory(String path) {	
	File f = null;
	try {
	  f = new File(path);
	} catch(NullPointerException ex)
	  { return new String[0]; }
	
	String[] names = f.list(new ExtensionFilter("class"));
	return names;
  }  
  // esplora la classe e estrae il numero massimo di livelli
  // della classe
  /*private int exploreLevel(int level, Class Eclass) {
	
	int MAXlevel = level ;
	Field[] attributes = Eclass.getFields();
	
	for (int i = 0; i < Array.getLength(attributes); i++)
	  if (!isPrimitive(attributes[i]))
	MAXlevel = exploreLevel(level + 1, attributes[i].getType());
	return MAXlevel;
  }
*/
  
 
  // gli viene fornita la classe e il metodo ne crea una istanza
  // leggendo i valori dai TextField
  
  private Object RecreateObject(Class Eclass) {
	
	Field[] attributes = Eclass.getFields();
	Constructor cons;
	Object o = null;
	
	try {
	  o = Eclass.newInstance();
	  Class[] parameterClass = new Class[1];
	  parameterClass[0] = Class.forName("java.lang.String");
	  
	  for (int k = 0;k < Array.getLength(attributes); k++ ) {
	if ( !isPrimitive(attributes[k]) ) {
	  // controllo la checkbox, ma anche se e' true (cioe' l'oggetto
	  // e' nullo) invoco comunque RecreateObject altrimenti non so 
	  // di quanto crescere l'indice per leggere i valori successivi
	  //,poi pero' non uso l'oggetto che viene ritornato
	  Object obj = null;
	  if (!((Checkbox)vecCheckBox.elementAt(index2++)).getState()) {
	    obj = RecreateObject(attributes[k].getType());
	    attributes[k].set(o, obj);
	  } else {
	    obj = RecreateObject(attributes[k].getType());
	    attributes[k].set(o, null);
	  }
	  
	} else {
	  
	  Object obj = null;
	  if(attributes[k].getType().equals(Class.forName("java.lang.Character"))) {
	    if (((TextField)vecField.elementAt(index1)).
		getText().trim().equals("null"))
	      obj = null;
	    else obj = 
		   new Character(((TextField)vecField.
				  elementAt(index1)).getText().trim().charAt(0));
	    index1++;
	  }	
	  else {
	    if (((TextField)vecField.elementAt(index1)).
		getText().trim().equals("null")) obj = null;
	    else {
	      Object[] parameterObject = new Object[1];
	      cons = attributes[k].getType().getConstructor(parameterClass);
	      parameterObject[0] =
		((TextField)vecField.elementAt(index1)).getText().trim();
	      obj = cons.newInstance(parameterObject);
	    }
	    index1++;
	  }
	  
	  attributes[k].set(o, obj);
	}
	  }		
	} catch (IllegalAccessException e) {System.out.println("Error:"+e);}
	catch (InstantiationException e) {System.out.println("Error:"+e);}
	catch (ClassNotFoundException e) {System.out.println("Error:"+e);}
	catch (NoSuchMethodException e) {System.out.println("Error:"+e);}
	catch (InvocationTargetException  e) {System.out.println("Error:"+e);}
	catch (Exception e) {System.out.println("Error:"+e);}
	return o;
  }  
  // quando il testo nella textarea cambia verifico che la checkbox
  // sia false (cioe' indichi che l'identita' e di agente)
  public void textValueChanged(TextEvent e) {
	// se l'utente sta introducendo dati e la checkbox e' false
	// la setto a true (siccome quando e' true indica che e' un 
	// gruppo)
	if (!lbl2.getState()) lbl2.setState(true);
  }  
}