package jive.graphics;

/*************************************************************************
 *  Questa classe consente di visualizzare una entry, ovvero permette di
 *  di vedere il valore dei suoi campi e parte dei dati relativi alla sua 
 *  ACL.
 *************************************************************************/
import java.lang.reflect.*;
import java.util.*;
import jive.util.*;
import java.io.*;
import java.awt.*;
import java.awt.event.*;
import jive.security.*;
import jive.javaSpace.*;


public class ShowEntryFrame implements ActionListener {

  private Button okbut;
  private Choice ch1, ch2,ch3;
  private TextField tf;
  private TextArea ta;
  private MARSInt space;
  private Frame SEF;
  private Panel SEP1;
  private Panel SEP2;
  private Entry E;
  
  // vecLabel e' il vettore che contiene tutte le label del panel
  private Vector vecLabel = new Vector();
  // vecField e' il vettore che contiene tutti i TextField  del Panel
  private Vector vecField = new Vector();
  private Vector vecCheckBox = new Vector();
  private int MAXlevel;
  
  private GridBagLayout grid1  = new GridBagLayout();
  private GridBagLayout grid2  = new GridBagLayout();
  // panel in cui si lavora (1versione)
  
  
  public ShowEntryFrame(Entry e, MARSInt sp) {
	
	E = e; space = sp;
	SEF = new Frame("--Show Entry Frame--");
	SEF.setLayout(new BorderLayout());
	SEF.setSize(400,300);
	// nel primo pannello vi e' la descrizione della Entry
	// con i campi, i loro nomi e i loro valori
	SEP1 = new Panel();
	SEP1.setLayout(grid1);
	SEP1.setBackground(Color.lightGray);
	
	// nel secondo vi e' la descrizione della Acl
	SEP2 = new Panel();
	SEP2.setLayout(grid2);
	SEP2.setBackground(Color.lightGray);
	
	GridBagConstraints gc = new GridBagConstraints();
	gc.weightx = 1.0;
	gc.weighty = 1.0;
	gc.gridwidth = GridBagConstraints.REMAINDER;
	gc.insets = new Insets(1, 1, 1, 1);
	gc.fill = GridBagConstraints.BOTH;
	gc.anchor = GridBagConstraints.WEST;
	
	Label label = new Label("Tuple content:");
	label.setForeground(Color.black);
	label.setBackground(Color.lightGray); // lightGray);
	label.setFont(new Font("Helvetica", Font.BOLD, 10));
	label.setAlignment(Label.LEFT);		
	grid1.setConstraints(label, gc);
	SEP1.add(label);
	
	
	// bottone di OK
	Button okbut = new Button("OK");
	okbut.setForeground(Color.white);
	okbut.setBackground(Color.darkGray);
	okbut.setFont(new Font("Helvetica", Font.PLAIN, 10));
	grid1.setConstraints(okbut, gc);
	SEP1.add(okbut);		
	
	// Metto un listener in ascolto sui due bottoni.
	okbut.addActionListener(this);
	
	SEF.add("South", okbut);
	SEF.add("North", SEP1);
	SEF.add("Center", SEP2);
	// non consento di modificare il valore dei campi
	SEP1.setEnabled(true);
	SEP2.setEnabled(true);
	
	// questo metodo non fa altro che visualizzare
	// la tupla 
	paintEntryPanel(0, E.getClass(), E);
	
	//paintAclPanel(E);
	
	SEF.setVisible(true);	
	SEF.validate();
	SEF.repaint();
  }  
  public void actionPerformed(ActionEvent e) {
	if (e.getActionCommand() == "OK") {
	  SEF.setVisible(false);
	}
  }  
  private boolean isPrimitive(Field F) {
	try { 
	  if ((F.getType()).equals(Class.forName("java.lang.String"))||
	  (F.getType()).equals(Class.forName("java.lang.Boolean"))||
	  (F.getType()).equals(Class.forName("java.lang.Short"))  ||
	  (F.getType()).equals(Class.forName("java.lang.Character"))||
	  (F.getType()).equals(Class.forName("java.lang.Byte"))   ||
	  (F.getType()).equals(Class.forName("java.lang.Integer"))||
	  (F.getType()).equals(Class.forName("java.lang.Long"))   ||
	  (F.getType()).equals(Class.forName("java.lang.Float"))  ||
	  (F.getType()).equals(Class.forName("java.lang.Double")) ||
	  (F.getType()).equals(Class.forName("java.lang.Void"))   ||
	  (F.getType()).equals(Class.forName("java.util.Date"))   ||
	  (F.getType()).equals(Class.forName("java.io.File"))     )		
	return true;
	  else return false;
	} catch(ClassNotFoundException e)
	  {System.out.println("Error:"+e); return false;}
  }  
  /*private void paintAclPanel(Entry e) {
	
	// panel SEP2
	SEP2.setLayout(grid2);
	Label lbl1 = new Label("Owner List");
	lbl1.setForeground(Color.black);
	lbl1.setBackground(Color.lightGray);
	lbl1.setFont(new Font("Helvetica", Font.BOLD, 10));
	lbl1.setAlignment(Label.LEFT);
	
	GridBagConstraints gc2 = new GridBagConstraints();
	gc2.insets = new Insets(1, 1, 1, 1);
	gc2.fill = GridBagConstraints.BOTH;
	gc2.weightx = 1.0;
	gc2.weighty = 1.0; 
	gc2.gridwidth = GridBagConstraints.REMAINDER;
	grid2.setConstraints(lbl1, gc2);
	SEP2.add(lbl1);
	
	// aggiungo il panel con il campo in cui si specifica il
	// tipo di entry al pannello globale
	
	if (e.getAcl() != null) ShowOwner(e);
	
	Label lbl2 = new Label("Access Control List");
	lbl2.setForeground(Color.black);
	lbl2.setBackground(Color.lightGray);
	lbl2.setFont(new Font("Helvetica", Font.BOLD, 10));
	lbl2.setAlignment(Label.LEFT);
	
	if (e.getAcl() != null) ShowPermission(e);		
	
	gc2.insets = new Insets(1, 1, 1, 1);
	gc2.fill = GridBagConstraints.BOTH;
	gc2.weightx = 1.0;
	gc2.weighty = 0.0;
	gc2.gridwidth = GridBagConstraints.REMAINDER;
	grid2.setConstraints(lbl2, gc2);
	SEP2.add(lbl2);
  } */ 
  private void paintEntryPanel( int level, Class Eclass, Object E) {
	
	String type = null;
	String prefix = null;
	String strLabel = null;
	Label label;
	GridBagConstraints gc;
	Field[] attributes = Eclass.getFields();
	
	System.out.println("*** Il valore di E e': "+E);
	for (int i = 0; i < Array.getLength(attributes); i++) {
	  // se il campo non e' primitivo il metodo si richiama
	  if ( !isPrimitive(attributes[i]) ) {
	try {
	  gc = new GridBagConstraints();
	  gc.weightx = 1.0;
	  gc.weighty = 1.0;
	  gc.insets = new Insets(1, 1, 1, 1);
	  gc.fill = GridBagConstraints.NONE;
	  gc.anchor = GridBagConstraints.WEST;	 
	  
	  prefix = "    ";
	  for(int m = 0; m < level; m++)
	    prefix = prefix + "-------";
	  
	  type = attributes[i].getType().toString();
	  strLabel = prefix+attributes[i].getName().trim()+"("+
	    type.substring(type.lastIndexOf(".")+1)+")";
	  label = new Label(strLabel);
	  // aggiungo la label all'array
	  vecLabel.addElement(label);
	  
	  gc.gridwidth = GridBagConstraints.RELATIVE;
	  gc.weightx = 1.0;		
	  grid1.setConstraints(label, gc);
	  
	  label.setForeground(Color.black);
	  label.setBackground(Color.lightGray); // lightGray);
	  label.setFont(new Font("Helvetica", Font.BOLD, 10));
	  label.setAlignment(Label.LEFT);		
	  SEP1.add(label);
	  
	  // con questa checkBox specifico se il campo di classe
	  // non primitiva e' un null reference o c'e' una istanza 
	  Checkbox cb = null;
	  if ((E == null) || (attributes[i].get((Object)E) == null))
	    cb = new Checkbox("Field null", true);
	  else 	cb = new Checkbox("Field null", false);
	  
	  vecCheckBox.addElement(cb);
	  gc.anchor = GridBagConstraints.WEST;
	  gc.fill = GridBagConstraints.NONE;
	  gc.gridwidth = GridBagConstraints.REMAINDER;
	  grid1.setConstraints(cb, gc);
	  
	  SEP1.add(cb);		
	  
	  if (E != null)
	    paintEntryPanel((level+1), attributes[i].getType(),
			  attributes[i].get((Object)E));
	  else  paintEntryPanel((level+1), attributes[i].getType(), null);
	} catch(IllegalAccessException ex)
	  {System.out.println("errore:"+ex);}
	  }			
	  else {
	
	   	gc = new GridBagConstraints();
	gc.weightx = 1.0;
	gc.weighty = 1.0;
	gc.insets = new Insets(1, 1, 1, 1);
	gc.fill = GridBagConstraints.NONE;
	gc.anchor = GridBagConstraints.WEST;	 
	
	prefix = "    ";
	for(int m = 0; m < level; m++)
	  prefix = prefix + "-------";
	
	type = attributes[i].getType().toString();
	strLabel = prefix+attributes[i].getName().trim()+"("+
	  type.substring(type.lastIndexOf(".")+1)+")";
	
	label = new Label(strLabel);
	// aggiungo la label all'array
	vecLabel.addElement(label);
	gc.gridwidth = GridBagConstraints.RELATIVE;
	grid1.setConstraints(label, gc);
	
	label.setForeground(Color.black);
	label.setBackground(Color.lightGray); 
	label.setFont(new Font("Helvetica", Font.BOLD, 10));
	label.setAlignment(Label.LEFT);		
	SEP1.add(label);
	
	TextField tf = null;
	try {		
	  if (attributes[i].get((Object)E) != null)
	    tf = 
	      new TextField(attributes[i].get((Object)E).toString(),20);
	  // scrivo null quando e' nullo il campo
	  else tf = new TextField("null", 20);
	} catch(IllegalAccessException ex)
	  {System.out.println("errore:"+ex);}
	catch(NullPointerException ex)
	  // non metto niente nel textfield quando l'oggetto
	  // relativo a quel campo e' nullo
	  {tf = new TextField("", 20);}
	
	// aggiungo il TextField all'array
	vecField.addElement(tf);
	gc.fill = GridBagConstraints.NONE;
	gc.anchor = GridBagConstraints.EAST;
	gc.gridwidth = GridBagConstraints.REMAINDER;
	grid1.setConstraints(tf, gc);
	SEP1.add(tf);		
	
	  }
	}
  }  
  /*public void ShowOwner(Entry e){
	Checkbox lbl;
	AgentIdentity id = null;
	Enumeration en = ((OwnerImpl)e.getAcl()).owners(); 
	for(;en.hasMoreElements();) { 
	  if ((id = (AgentIdentity)en.nextElement()) instanceof AgentGroup) 
	lbl = new Checkbox("Agent/Group Identity:", true); 
	  else 	lbl = new Checkbox("Agent/Group Identity:", false);
	  lbl.setForeground(Color.black);
	  lbl.setBackground(Color.lightGray);
	  lbl.setFont(new Font("Helvetica", Font.BOLD, 10));
	  
	  TextField tf  = new TextField(id.getName(), 15); 	
	  GridBagConstraints gc3 = new GridBagConstraints();
	  gc3.insets = new Insets(1, 1, 1, 1);
	  gc3.fill = GridBagConstraints.BOTH;
	  gc3.weightx = 1.0;
	  gc3.weighty = 1.0;
	  gc3.fill = GridBagConstraints.BOTH;
	  gc3.gridwidth = GridBagConstraints.RELATIVE;
	  
	  // la grid e' ancora la 2 siccome lbl deve essere 
	  // posta nel Panel SEP2
	  grid2.setConstraints(lbl, gc3);
	  SEP2.add(lbl);
	  gc3.gridwidth = GridBagConstraints.REMAINDER;
	  grid2.setConstraints(tf, gc3);
	  SEP2.add(tf);
	}
  }  
  private void ShowPermission(Entry e) {
	
	AclEntryImpl tae = null;
	Enumeration en = e.getAcl().entries(); 
	Checkbox lbl;
 
	for(;en.hasMoreElements();) { 
	  tae = (AclEntryImpl)en.nextElement();
	  if (tae.getPrincipal() instanceof AgentGroup)
	lbl = new Checkbox("Agent/Group Identity:", true);
	  else  	lbl = new Checkbox("Agent/Group Identity:", false);
	  
	  lbl.setForeground(Color.black);
	  lbl.setBackground(Color.lightGray);
	  lbl.setFont(new Font("Helvetica", Font.BOLD, 10));
	  
	  TextField tf = new TextField(tae.getPrincipal().getName(), 15); 
	  
	  Checkbox lbl1;
	  if (tae.checkPermission(new PermissionImpl("READ")))
	lbl1 = new Checkbox("read permission", true);
	  else	lbl1 = new Checkbox("read permission", false);
	  
	  lbl1.setForeground(Color.black);
	  lbl1.setBackground(Color.lightGray);
	  lbl1.setFont(new Font("Helvetica", Font.BOLD, 10));
	  
	  Checkbox lbl2 = null;
	  if (tae.checkPermission(new PermissionImpl("TAKE")))
	lbl2 = new Checkbox("take permission", true);
	  else	lbl2 = new Checkbox("take permission", false);
	  
	  lbl2.setForeground(Color.black);
	  lbl2.setBackground(Color.lightGray);
	  lbl2.setFont(new Font("Helvetica", Font.BOLD, 10));
	  
	  GridBagConstraints gc3 = new GridBagConstraints();
	  gc3.insets = new Insets(1, 1, 1, 1);
	  gc3.weightx = 1.0;
	  gc3.weighty = 1.0;
	  gc3.fill = GridBagConstraints.BOTH;
	  gc3.gridwidth = GridBagConstraints.RELATIVE;
	  grid2.setConstraints(lbl, gc3);
	  SEP2.add(lbl);
	  
	  gc3.gridwidth = GridBagConstraints.REMAINDER;
	  grid2.setConstraints(tf, gc3);
	  SEP2.add(tf);
	  
	  gc3.gridwidth = GridBagConstraints.RELATIVE;
	  grid2.setConstraints(lbl1, gc3);
	  SEP2.add(lbl1);
	  
	  gc3.gridwidth = GridBagConstraints.REMAINDER;
	  grid2.setConstraints(lbl2, gc3);
	  SEP2.add(lbl2);
	}
 */ }  
}