package jive.graphics;

/*************************************************************************
 *  Questa classe consente di visualizzare una reaction entry.
 *************************************************************************/

import java.lang.reflect.*;
import java.util.*;
import jive.util.*;
import java.io.*;
import java.awt.*;
import java.awt.event.*;
import jive.security.*;
import jive.javaSpace.*;

public class ShowReactionFrame implements ActionListener{

  private Button okbut;
  private Choice ch1, ch2,ch3;
  private TextField tf;
  private TextArea ta;
  private MARS space;
  private Frame SRF;
  private Panel SRP1;
  private Panel SRP2;
  private Entry RE;
  
  public ShowReactionFrame(Entry re, MARS sp) { //meglio Entry?
	
	RE = re; space = sp;
	SRF = new Frame("--Show Reaction Frame--");
	SRF.setLayout(new BorderLayout());
	SRF.setSize(400,300);
	SRP1 = new Panel();
	SRP2 = new Panel();
	SRP2.setBackground(Color.lightGray);
	
	// bottone di OK
	Button okbut = new Button("OK");
	okbut.setForeground(Color.white);
	okbut.setBackground(Color.darkGray);
	okbut.setFont(new Font("Helvetica", Font.PLAIN, 10));
	
	// Metto un listener in ascolto
	okbut.addActionListener(this);
	
	SRF.add("South", okbut);
	SRF.add("North", SRP1);
	SRF.add("Center", SRP2);
	// non consento di modificare il valore dei campi
	SRP1.setEnabled(false);
	SRP2.setEnabled(false);
	
	// questo metodo non fa altro che visualizzare
	// la tupla 
	if (RE.getEntry() != null)
	  new ShowTuplePanel( RE.getEntry(), SRP2);
	paintPanel();		
	
	SRF.setVisible(true);	
	SRF.validate();
	SRF.repaint();
  }  
  public void actionPerformed(ActionEvent e) {

	if (e.getActionCommand() == "OK") {
	  SRF.setVisible(false);
	}
  }  
  public  void paintPanel(){
	GridBagLayout grid = new GridBagLayout();
	SRP1.setLayout(grid);
	
	Label lbl1 = new Label("Reaction type:");
	lbl1.setForeground(Color.black);
	lbl1.setBackground(Color.lightGray);
	lbl1.setFont(new Font("Helvetica", Font.BOLD, 10));
	lbl1.setAlignment(Label.CENTER);
	
	// campo di selezione della reazione
	ch1 = new Choice();
	String REC = RE.getReaction().getClass().toString();
	ch1.addItem(REC.substring(REC.lastIndexOf(".")+1));
		
	Checkbox lbl2 = null;
	if (RE.getIdentity() instanceof AgentGroup)
	  // quando e' l'identita' e' un gruppo la checkbox la metto a true
	  lbl2 = new Checkbox("Agent/Group Identity:", true);
	else  lbl2 = new Checkbox("Agent/Group Identity:", false);
	lbl2.setForeground(Color.black);
	lbl2.setBackground(Color.lightGray);
	lbl2.setFont(new Font("Helvetica", Font.BOLD, 10));
	
	if (RE.getIdentity() == null) 
	  tf = new TextField("null", 15);
	else tf = new TextField(RE.getIdentity().getName(), 15);
	
	Label lbl6 = new Label("Member:");
	lbl6.setForeground(Color.black);
	lbl6.setBackground(Color.lightGray);
	lbl6.setFont(new Font("Helvetica", Font.BOLD, 10));
	lbl6.setAlignment(Label.CENTER);
	
	// creo una textarea con 2 righe e 10 colonne
	// in cui vengono memorizzati i membri del gruppo
	ta = new TextArea(3, 10);
	ta.setEditable(true);
	if (RE.getIdentity() instanceof AgentGroup) {
	  String buffer = "";
	  Enumeration en = ((AgentGroup)RE.getIdentity()).members();
	  for(;en.hasMoreElements();) 
	buffer+="\n"+en.nextElement().toString();
	  ta.setText(buffer);
	}
	
	Label lbl3 = new Label("Entry Type:");
	lbl3.setForeground(Color.black);
	lbl3.setBackground(Color.lightGray);
	lbl3.setFont(new Font("Helvetica", Font.BOLD, 10));
	lbl3.setAlignment(Label.CENTER);
	
	
	// campo di selezione del tipo di tupla
	ch2 = new Choice();
	String EC = "null";
	if (RE.getEntry() != null) {
	  RE.getEntry().getClass().toString();
	  ch2.addItem(EC.substring(EC.lastIndexOf(".")+1));
	}
	ch2.addItem(EC);
	
	Label lbl4 = new Label("Operation Type:");
	lbl4.setForeground(Color.black);
	lbl4.setBackground(Color.lightGray);
	lbl4.setFont(new Font("Helvetica", Font.BOLD, 10));
	lbl4.setAlignment(Label.CENTER);
	
	// campo di selezione del tipo di operazione
	ch3 = new Choice();
	ch3.addItem(RE.getOperation());
	
	// define the constraints
	GridBagConstraints gc = new GridBagConstraints();
	gc.insets = new Insets(1, 1, 1, 1);
	gc.fill = GridBagConstraints.BOTH;
	gc.weightx = 1.0;
	gc.weighty = 1.0;
	
	gc.gridwidth = GridBagConstraints.RELATIVE;
	grid.setConstraints(lbl1, gc);
	
	gc.gridwidth = GridBagConstraints.REMAINDER;
	grid.setConstraints(ch1, gc);
	SRP1.add(lbl1);
	SRP1.add(ch1);
	
	gc.fill = GridBagConstraints.BOTH;
	gc.gridwidth = GridBagConstraints.RELATIVE;
	grid.setConstraints(lbl2, gc);
	gc.gridwidth = GridBagConstraints.REMAINDER;
	grid.setConstraints(tf, gc);
	SRP1.add(lbl2);
	SRP1.add(tf);
	
	gc.fill = GridBagConstraints.BOTH;
	gc.gridwidth = GridBagConstraints.RELATIVE;
	grid.setConstraints(lbl6, gc);
	gc.gridwidth = GridBagConstraints.RELATIVE;
	grid.setConstraints(ta, gc);
	SRP1.add(lbl6);
	SRP1.add(ta);
	
	gc.fill = GridBagConstraints.BOTH;
	gc.gridwidth = GridBagConstraints.RELATIVE;
	grid.setConstraints(lbl3, gc);
	gc.gridwidth = GridBagConstraints.REMAINDER;
	grid.setConstraints(ch2, gc);
	SRP1.add(lbl3);
	SRP1.add(ch2);
	
	gc.fill = GridBagConstraints.BOTH;
	gc.gridwidth = GridBagConstraints.RELATIVE;
	grid.setConstraints(lbl3, gc);
	gc.gridwidth = GridBagConstraints.REMAINDER;
	grid.setConstraints(ch2, gc);
	SRP1.add(lbl3);
	SRP1.add(ch2);
	
	gc.fill = GridBagConstraints.BOTH;
	gc.gridwidth = GridBagConstraints.RELATIVE;
	grid.setConstraints(lbl4, gc);
	gc.gridwidth = GridBagConstraints.REMAINDER;
	grid.setConstraints(ch3, gc);
	SRP1.add(lbl4);
	SRP1.add(ch3);
	
	SRP1.setVisible(true);
	SRP1.validate();
	SRP1.repaint();
  }  
}