package jive.graphics;

/*************************************************************************
 *  Questa classe consente di visualizzare una entry, ed e' utilizzata 
 *  dalla classe ShowReactionFrame.
 *************************************************************************/
import java.lang.reflect.*;
import java.util.*;
import jive.util.*;
import java.io.*;
import java.awt.*;
import java.awt.event.*;
import jive.security.*;
import jive.javaSpace.*;

class ShowTuplePanel{
	
  // questa e' la classe della entry 
  private Entry E;
  private Space space;
  private Field[] attributes;
  // vecLabel e' il vettore che contiene tutte le label del panel
  private Vector vecLabel = new Vector();
  // vecField e' il vettore che contiene tutti i TextField  del Panel
  private Vector vecField = new Vector();
  private Vector vecCheckBox = new Vector();
  
  private GridBagLayout grid  = new GridBagLayout();
	// panel in cui si lavora (1versione)
	private Panel STP;
	
  public ShowTuplePanel (Entry e, Panel stp) {
	
	STP = stp;  E = e;
	STP.setBackground(Color.lightGray);
	STP.setLayout(grid);
	
	PrintLabel(0, E.getClass(), E);
	STP.setVisible(true);
	STP.validate();
	STP.repaint();
  }  
  private boolean isPrimitive(Field F) {
	try { 
	  if ((F.getType()).equals(Class.forName("java.lang.String"))||
	  (F.getType()).equals(Class.forName("java.lang.Boolean"))||
	  (F.getType()).equals(Class.forName("java.lang.Short"))  ||
	  (F.getType()).equals(Class.forName("java.lang.Character"))||
	  (F.getType()).equals(Class.forName("java.lang.Byte"))   ||
	  (F.getType()).equals(Class.forName("java.lang.Integer"))||
	  (F.getType()).equals(Class.forName("java.lang.Long"))   ||
	  (F.getType()).equals(Class.forName("java.lang.Float"))  ||
	  (F.getType()).equals(Class.forName("java.lang.Double")) ||
	  (F.getType()).equals(Class.forName("java.lang.Void"))   ||
		  (F.getType()).equals(Class.forName("java.util.Date"))   ||
		  (F.getType()).equals(Class.forName("java.io.File"))  )		
	return true;
	  else return false;
	} catch(ClassNotFoundException e)
	  {System.out.println("Error:"+e); return false;}
  }  
  private void PrintLabel( int level, Class Eclass, Object E) {
	
	String type = null;
	String prefix = null;
	String strLabel = null;
	Label label;
	GridBagConstraints gc;
	Field[] attributes = Eclass.getFields();
	
	System.out.println("***  Il valore di E e': "+E);
	for (int i = 0; i < Array.getLength(attributes); i++) {
	  // se il campo non e' primitivo il metodo si richiama
	  if ( !isPrimitive(attributes[i]) ) {
	try {
	  gc = new GridBagConstraints();
	  gc.weightx = 1.0;
	  gc.weighty = 1.0;
	  gc.insets = new Insets(1, 1, 1, 1);
	  gc.fill = GridBagConstraints.NONE;
	  gc.anchor = GridBagConstraints.WEST;	 
	  
	  prefix = "    ";
	  for(int m = 0; m < level; m++)
	    prefix = prefix + "-------";
	  
	  
	  type = attributes[i].getType().toString();
	  strLabel = prefix+attributes[i].getName().trim()+"("+
	    type.substring(type.lastIndexOf(".")+1)+")";
	  label = new Label(strLabel);
	  // aggiungo la label all'array
	  vecLabel.addElement(label);
	  
	  gc.gridwidth = GridBagConstraints.RELATIVE;
	  gc.weightx = 1.0;		
	  grid.setConstraints(label, gc);
	  
	  label.setForeground(Color.black);
	  label.setBackground(Color.lightGray); 
	  label.setFont(new Font("Helvetica", Font.BOLD, 10));
	  label.setAlignment(Label.LEFT);		
	  STP.add(label);
	  
	  // con questa checkBox specifico se il campo di classe
	  // non primitiva e' un null reference o c'e' una istanza 
	  Checkbox cb = null;
	  if ( (E == null) || (attributes[i].get((Object)E) == null)) 
	    cb = new Checkbox("Field null", true);
	  else 	cb = new Checkbox("Field null", false);
	  
	  vecCheckBox.addElement(cb);
	  gc.anchor = GridBagConstraints.WEST;
	  gc.fill = GridBagConstraints.NONE;
	  gc.gridwidth = GridBagConstraints.REMAINDER;
	  grid.setConstraints(cb, gc);
	  
	  STP.add(cb);		
	  
	  if (E != null)
	    PrintLabel((level+1), attributes[i].getType(),
		     attributes[i].get((Object)E));
	  else PrintLabel((level+1), attributes[i].getType(), null);
	} catch(IllegalAccessException ex)
	  {System.out.println("errore:"+ex);}
	  }			
	  else {
		gc = new GridBagConstraints();
	gc.weightx = 1.0;
	gc.weighty = 1.0;
	gc.insets = new Insets(1, 1, 1, 1);
	gc.fill = GridBagConstraints.NONE;
	gc.anchor = GridBagConstraints.WEST;	 
	
	prefix = "    ";
	for(int m = 0; m < level; m++)
	  prefix = prefix + "-------";
	
	type = attributes[i].getType().toString();
	strLabel = prefix+attributes[i].getName().trim()+"("+
	  type.substring(type.lastIndexOf(".")+1)+")";
	
	label = new Label(strLabel);
	// aggiungo la label all'array
	vecLabel.addElement(label);
	gc.gridwidth = GridBagConstraints.RELATIVE;
	grid.setConstraints(label, gc);
	
	label.setForeground(Color.black);
	label.setBackground(Color.lightGray); 
	label.setFont(new Font("Helvetica", Font.BOLD, 10));
	label.setAlignment(Label.LEFT);		
	STP.add(label);
	
	TextField tf = null;
	try {		
	  if (attributes[i].get((Object)E) != null)
	    tf = 
	      new TextField(attributes[i].get((Object)E).toString(),
			    10);
	  // scrivo null quando e' nullo il campo
	  else tf = new TextField("null", 10);
	} catch(IllegalAccessException ex)
	  {System.out.println("errore:"+ex);}
	catch(NullPointerException ex)
	  // non metto nienete nel textfield quando l'oggetto
	  // relativo a quel campo  nullo
	  {tf = new TextField("", 10);}
	
	// aggiungo il TextField all'array
	vecField.addElement(tf);
	gc.fill = GridBagConstraints.NONE;
	gc.anchor = GridBagConstraints.EAST;
	
	gc.gridwidth = GridBagConstraints.REMAINDER;
	grid.setConstraints(tf, gc);
	STP.add(tf);		
	
	  }
	}
  }  
}