package jive.graphics;

/**************************************************************************

   Copyright (c) 1996 The Regents of the University of California.
   All rights reserved.

   -------------

   $Id: StatusPanel.java,v 1.1 1996/08/06 11:14:09 wli Exp wli $

   Class StatusPanel: places output with several maintainence buttons

**************************************************************************/

import java.awt.*;
import java.applet.*;
import java.awt.event.*;
import java.util.*;
import jive.util.Passer;


public class StatusPanel extends Thread implements ActionListener{

  private   TextArea txt;
  private  Button cbut;
  //Button abut;
  private Passer pin;
  private Panel SP;
  private boolean stop = false;
  private Vector statusvector = new Vector();

	public StatusPanel(String aliasName, int serverPort,
			   int hallPort, Panel p, Passer Pin, Vector StatusVector) {
	  statusvector = StatusVector;
	  pin = Pin;
	  SP = p;
	  
	  // define the layout manager
	  GridBagLayout grid = new GridBagLayout();
	  p.setLayout(grid);
	  
	  // write the labels
	  Label aliaslbl = new Label(aliasName.toUpperCase());
	  aliaslbl.setForeground(Color.black);
	  aliaslbl.setBackground(Color.lightGray);
	  aliaslbl.setFont(new Font("Helvetica", Font.BOLD, 10));
	  aliaslbl.setAlignment(Label.CENTER);
	  
	  Label serverlbl = new Label("Class Server Port: "+serverPort);
	  serverlbl.setForeground(Color.black);
	  serverlbl.setBackground(Color.lightGray);
	  serverlbl.setFont(new Font("Helvetica", Font.BOLD, 10));
	  serverlbl.setAlignment(Label.CENTER);
	  
	  Label communelbl = new Label("Hall Server Port: "+hallPort);
	  communelbl.setForeground(Color.lightGray);
	  communelbl.setBackground(Color.black);
	  communelbl.setFont(new Font("Helvetica", Font.BOLD, 10));
	  communelbl.setAlignment(Label.CENTER);
	  
	  // now, the active components
	  txt  = new TextArea(5, 20);
	  txt.setFont(new Font("Helvetica", Font.PLAIN, 10));
	  txt.setEditable(false);
	  txt.setBackground(Color.white);
	  
	  cbut = new Button("Clear");
	  cbut.setForeground(Color.white);
	  cbut.setBackground(Color.black);
	  cbut.setFont(new Font("Helvetica", Font.PLAIN, 10));
	  
	  /*abut = new Button("Cancel");
		abut.setForeground(Color.white);
		abut.setBackground(Color.black);
	abut.setFont(new Font("Helvetica", Font.PLAIN, 10));*/
	  
	  // define the constraints
	  GridBagConstraints gc = new GridBagConstraints();
	  gc.gridwidth = GridBagConstraints.REMAINDER;
	  gc.fill = GridBagConstraints.BOTH;
	  gc.weightx = 1.0;
	  gc.weighty = 0.0;
	  

	  grid.setConstraints(aliaslbl, gc);
	  gc.gridwidth = GridBagConstraints.RELATIVE;
	  grid.setConstraints(serverlbl, gc);
	  gc.gridwidth = GridBagConstraints.REMAINDER;
	  grid.setConstraints(communelbl, gc);
	  p.add(aliaslbl);
	  p.add(serverlbl);
	  p.add(communelbl);
	  
	  gc = new GridBagConstraints();
	  gc.weightx = 1.0;
	  gc.weighty = 1.0;
	  
	  gc.fill = GridBagConstraints.BOTH;
	  gc.gridwidth = GridBagConstraints.REMAINDER;
	  grid.setConstraints(txt, gc);
	  p.add(txt);
	  
	  gc = new GridBagConstraints();
	  gc.weightx = 1.0;
	  //gc.weighty = 1.0;
	  
	  gc.fill = GridBagConstraints.HORIZONTAL;
	  gc.gridwidth = GridBagConstraints.REMAINDER;
	  grid.setConstraints(cbut, gc);
	  p.add(cbut);
	  
	  /*			gc.gridwidth = GridBagConstraints.REMAINDER;
				grid.setConstraints(abut, gc);
				p.add(abut);*/
	  
	  // Metto un listener in ascolto sui due bottoni.
	  cbut.addActionListener(this);
	  
	  for(Enumeration e = statusvector.elements();e.hasMoreElements();)
	txt.appendText(((String)e.nextElement())+"\n" );
	  //abut.addActionListener(this);		
	  SP.setVisible(true);
	  SP.validate();
	  SP.repaint();
	}
  public void actionPerformed(ActionEvent e) {

	if (e.getActionCommand() == "Clear") {
	  txt.selectAll();
	  txt.replaceText("",
		      txt.getSelectionStart(), txt.getSelectionEnd());
	  statusvector.removeAllElements();
	}
	if (e.getActionCommand() == "Stop-monitor") {
	  stop = false;
	  SP.setVisible(false);	
	}
  }  
  // text handling
  public void run() {
	
	String stuff;
	while (!stop) {
	  stuff = (String) pin.get(); //AndNotRemove();
	  txt.appendText(stuff + "\n");
	  statusvector.addElement(stuff);
	}
  }  
}