package jive.security;

//MD
/**********************************************************************
 * Questa classe permette di rappresentare gruppi di agenti.
 *********************************************************************/

import java.security.*;
import java.security.acl.*;
import java.util.*;

public class AgentGroup extends AgentIdentity  implements Group{
  
  private Hashtable list = new Hashtable();
  
  protected AgentGroup() {
	super("restoring...");
  }  
  public AgentGroup(String name) {
	super(name);
  }  
  public AgentGroup(String name,IdentityScope scope) 
	   throws KeyManagementException {
	 super(name, scope);
  }  
/**********************************************************************
 *  Questo metodo permette di aggiungere un membro al gruppo la cui 
 *  identita' e' specificata da user. Se viene effettivamente inserito 
 *  il metodo ritorna true, false altrimenti.
 *********************************************************************/	

  public boolean addMember(Principal user) {
	AgentIdentity AI = 
	(AgentIdentity) list.get(user.getName());
	if (AI.equals(user)) return false;
	list.put(user.getName(),user);
	return true;
  }  
/**********************************************************************
 *  Questo metodo restituisce true se l'agente specificato tramite il
 *  parametro passato appartiene al gruppo.
 *********************************************************************/
  public boolean isMember(Principal member) {
	return list.containsKey(member.getName());
  }  
/**********************************************************************
 * Questo metodo fornisce una istanza della classe Enumeration che 
 * permette di analizzare i membri del gruppo.
 *********************************************************************/
  public Enumeration members() {
	return list.elements();
  }  
/**********************************************************************
 *  Questo metodo permette di rimuovere un membro dal gruppo, e 
 *  restituisce true se l'elemento viene effettivamente eliminato e 
 *  false in caso contrario.
 *********************************************************************/
  public boolean removeMember(Principal user) {
	return ( list.remove(user.getName()) != null) ;
  }  
  public String toString() {
	return "Group-"+super.toString();
  }  
/**********************************************************************
 * I due metodi che seguono forniscono due rappresentazioni stampabili
 * (la seconda piu' dettagliata della prima) della classe.
 *********************************************************************/
   public String toString(boolean detailed) {
	String tmp = "";
	Enumeration e = list.elements();
	for(;e.hasMoreElements();)
	  tmp+=((AgentIdentity)e.nextElement()).getName()+" ,";
	return super.toString(detailed)+"\n\t members: "+tmp;
  }  
}