package jive.security;

//MD
/**********************************************************************
 * Questo classe consente di rappresentare l'identity scope di uno
 * spazio. E' da notare che molti dei metodi non sono stati 
 * implementati.
 *********************************************************************/
 
import java.util.*;
import java.security.*;


public class AgentIdentityScope extends IdentityScope 
		implements java.io.Serializable,Cloneable {

  private Hashtable ids = new Hashtable();


  protected AgentIdentityScope() {
	super("restoring...");
  }  
  public AgentIdentityScope(String name) {
	super(name);
  }  
  public AgentIdentityScope(String name, IdentityScope scope) 
	   throws KeyManagementException {
	 super(name, scope);
  }  
  public void addIdentity(Identity identity) 
	   throws KeyManagementException {
	   if ( ids.containsKey(identity.getName()) ) throw new KeyManagementException();
	   ids.put(identity.getName(),identity);
	   }   
  public Identity getIdentity(String name) {
  	return ((Identity) ids.get(name));
  	}  
  //Gestione PublicKey non implementata
  public Identity getIdentity(PublicKey key) {return null;}  
  public Enumeration identities() { return ids.elements(); }  
  public void removeIdentity(Identity identity) 
	   throws KeyManagementException {
	   if ( ids.remove(identity.getName()) == null ) throw new KeyManagementException();
	   }   
  public int size() { return ids.size(); }  
}