package jive.security;

//MD
/**********************************************************************
 * Questo classe consente di rappresentare l'identity scope di uno
 * spazio. 
 *********************************************************************/
 
import java.util.*;
import java.security.*;

public class SpaceIdentityScope extends AgentIdentityScope {
 
  private Hashtable rev = new Hashtable();

  protected SpaceIdentityScope() {
	super("restoring...");
  }  
  public SpaceIdentityScope(String name) {
	super(name);
  }  
  public SpaceIdentityScope(String name, IdentityScope scope) 
	   throws KeyManagementException {
	 super(name, scope);
  }  
  public void addIdentity(Identity id) 
	   throws KeyManagementException {
	   SpaceIdentity identity = (SpaceIdentity) id;
	   super.addIdentity(identity);
	   Vector v = (Vector) rev.get(identity.address());
	   if ( v != null ) {
		 v.addElement(identity);
	   }
	   else {
	   v = new Vector();
	   v.addElement(identity);
	   rev.put(identity.address(),v);
	   }
   }   
  public void removeIdentity(Identity id)
	   throws KeyManagementException {
	   SpaceIdentity identity = (SpaceIdentity) id;
	   super.removeIdentity(identity);
	   Vector v = (Vector) rev.get(identity.address());
	   v.removeElement(identity);
	   if ( v.size() == 0 ) rev.remove(identity.address());
	   }   
  public Enumeration spaces(String add) {
	return ((Vector) rev.get(add)).elements();  	
  }  
}