package jive.util;

/*************************************************************************
 *  Questa classe rappresenta la struttura dati dello spazio che memorizza 
 *  le tuple dello spazio.
 *  La struttura si basa su un vettore, che pero' viene riorganizzato 
 *  (cioe' ridimensionato in base alle cance) solo
 *************************************************************************/

import java.util.*;

final
class SpaceVectorEnumerator implements Enumeration {
	SpaceVector vector;
	int count;

	SpaceVectorEnumerator(SpaceVector v) {
	vector = v;
	count = 0;
	}
	public int getCurrentIndex() {
	return count;
	}
	public boolean hasMoreElements() {
	return count < vector.elementCount;
	}
	public Object nextElement() {
	synchronized (vector) {
	    if (count < vector.elementCount) {
		return vector.elementData[count++];
	    }
	}
	throw new NoSuchElementException("VectorEnumerator");
	}
}