package jive.javaSpace;


/*************************************************************************
 *  Questa classe e' la superclass di tutte le tuple che possono essere 
 *  lasciate nello spazio di tuple. In questa classe viene predisposto 
 *  un campo che memorizza la data (che viene fissata dal metodo di 
 *  write della classe Space alla scrittura nello spazio) e un campo che
 *  memorizza la Access Control List (ACL) per quella tupla. Notare che  
 *  tale ACL se e' presente puo' essere fissata solo alla creazione della
 *  tupla e non puo' essere modificata nel seguito. Per potere variare le 
 *  caratteristiche (e in particolare l'ACL) e' necessario togliere la tupla 
 *  e rimetterla, e quindi se un agente possiede i diritti per toglierla puo'
 *  semplicemente rimetterne un'altra uguale con solo i diritti cambiati.
 *************************************************************************/

import java.security.acl.Acl;

public interface Entry extends java.io.Serializable {

 
/*************************************************************************
 *  Questo metodo restituisce la ACL.
 *************************************************************************/
  public Acl getAcl();
 
/*************************************************************************
 *  Questo metodo setta la Access Control List (se non e' ancora stata 
 *  settata)
 *************************************************************************/
  public void setAcl(Acl a);

 public void showValues();
   
}

  
	

