package jive.javaSpace;  //da finire
/************
*Questa classe fornisce un'implementazione di Lease Policy e garantisce che la 
*entry inserita nello spazio rimanga inserita per il valore richiesto e concesso.
*In particolare se  specificato il tempo massimo, il tempo massimo della politica;
*se non  specificato alcun valore per il valore di default. In millisecondi.
***********
*/
import net.jini.core.lease.Lease;
import net.jini.core.lease.LeaseDeniedException;
import net.jini.core.lease.LeasePolicy;
import java.security.*;
import java.lang.IllegalArgumentException;
public class LeaseMarsPolicy  {

final private long maximum;
final private long defaultl;

public LeaseMarsPolicy(long maximum, long defaultl) {
	if (!(maximum > 0) )
		throw new IllegalArgumentException("maximum non pu essere 0");
	if (!(defaultl > 0) )
		throw new IllegalArgumentException("default non pu essere 0");
this.maximum = maximum;
this.defaultl = defaultl;
}

/***************
* ritorna l'oggetto Lease per la risorsa specificata.
***************
*/
public Lease leaseFor (EntryRep entry, long lease)
throws LeaseDeniedException
{
final long now = System.currentTimeMillis();
final long expiration = Expiration(calcDuration(entry,lease), now);
final long duration = expiration - now;
final Lease newLease = new LeaseImpl(entry,duration);
entry.setExpiration(expiration); //ricorda che non  entry, ma entryRep
return newLease;
}

protected long calcDuration (EntryRep entry, long lease) {
if (lease == Lease.FOREVER)
lease = Long.MAX_VALUE;
else if (lease == Lease.ANY)
lease = defaultl;
else if (lease < 0)
System.out.println("negativo");
//throw IllegalArgumentException("negativo");
return Math.min(lease, maximum);
}



private long Expiration( long preferredlease, long now) {
long expiration = now + preferredlease;
if (expiration < 0) {
return Long.MAX_VALUE;
}
return expiration;
}
}