package jive.javaSpace;

import jive.security.*;
import java.security.*;
import java.util.*;
import jive.util.Passer;
import net.jini.core.event.*;
import net.jini.core.lease.*;
import java.rmi.*;

/***********************************************************************************
 *  l'interfaccia vero e proprio di alto livello, cio quello che dichiara le funzioni
 * cos come vengono invocate dagli agenti (chiamata a tre parametri e non a quattro, come 
 * invece avviene per MARSInt)
 * l'invocazione di un metodo su MARS comporta sempre e comunque l'invocazione del 
 * corrispondente metodo Linda su MARSInt, cio l'interfaccia di livello immediatamente inferiore
 **********************************************************************************/

public interface MARS {

	Entry read (Entry entry, Transaction txn, long timeout) throws NotInterfaceOwnerException,
   		NoPermissionException;
  
	Entry[] readAll (Entry entry, Transaction txn, long timeout) throws NotInterfaceOwnerException,
   		NoPermissionException;   
  
	Entry take (Entry entry, Transaction txn, long timeout) throws NotInterfaceOwnerException,
		NoPermissionException;
  
	Entry[] takeAll (Entry entry, Transaction txn, long timeout) throws NotInterfaceOwnerException,
		NoPermissionException;
 
	Lease write(Entry entry, Transaction txn, long lease) 
		throws NotInterfaceOwnerException, NoPermissionException;

	public EventRegistration notify (Entry tmpl, Transaction tr, RemoteEventListener
		listener, long leaseTime, Object handback)
		throws  RemoteException ;

	public void print(String msg);
 
}