package jive.javaSpace;

import jive.security.*;
import java.security.*;
import java.security.acl.*;
import java.util.*;
import jive.util.Passer;
import net.jini.core.event.*;
import net.jini.core.lease.*;
import java.rmi.*;

/********************************************************************
 * a differenza di MARS, questa interfaccia si colloca a livello pi basso,
 * cio pi vicino al tuplespace
 * questi metodi vanno ad agire sulle tuple dello spazio passivo o delle
 * reazioni attraverso le operazioni Linda
 * possiamo dire che l'interfaccia MARSInt si colloca sotto quella MARS, ossia
 * un'invocazione di un metodo su MARS comporta sempre l'invocazione del
 * corrispondente metodo Linda di MARSInt
 ***********************************************************************/

public interface MARSInt {

 
	Entry read (Entry entry, Transaction txn,long timeout, Principal who) 
		throws NotInterfaceOwnerException, NoPermissionException;
  
	Entry[] readAll (Entry entry, Transaction txn,long timeout,Principal who) 
		throws NotInterfaceOwnerException,NoPermissionException;   
  
	Entry take (Entry entry, Transaction txn,long timeout, Principal who) 
		throws NotInterfaceOwnerException, NoPermissionException;
  
	Entry[] takeAll (Entry entry, Transaction txn,long timeout,Principal who) 
		throws NotInterfaceOwnerException,NoPermissionException;
 
  	Lease write(Entry entry, Transaction txn,long lease, Principal who) 
		throws NotInterfaceOwnerException, NoPermissionException;

	public EventRegistration notify (Entry tmpl, Transaction tr, 
		RemoteEventListener listener, long leaseTime, Object handback)
	throws RemoteException ;//TransactionException, 

	public void expire();

	//public void print(String msg);
	
	public Vector getNotifyVector();

	//public Vector getNotifyMetaVector();

	public NotifyRecord getNotifyRecord();
	
	public boolean checkPermission(Principal principal, Permission permission);
}