package jive.javaSpace;

/**********************************************************************
 *  La classe sottostante rappresenta il Thread manager. Tale entita' 
 *  ha il compito di mandare in esecuzione le reazioni, e di 
 *  mantenere una lista di quelli in esecuzione. A tale scopo vi e' un 
 *  metodo che controlla se il processo e' in esecuzione, se non lo e' 
 *  viene tolto dalla lista di quelli attivi (pero' non essendo un 
 *  Thread deve essere invocato da un Thread).
 *********************************************************************/

import java.util.*;

import jive.security.*;
import java.security.*;
import jive.util.Passer;
import jive.util.*;


public class RThreadManager 
{
	Hashtable list = new Hashtable();
  
		// Il vettore contiene la lista dei Thread lanciati
	ThreadGroup Tgroup;
	  
		// passer di comunicazione con l'intefaccia grafica
	Passer pout;
  

public RThreadManager(Passer Pout) 
{
	pout = Pout;
	try { 
		//AccessController.beginPrivileged();
		Tgroup = new ThreadGroup("Reactions");
	} 
	finally {
		//AccessController.endPrivileged();
	}
}


/**********************************************************************
 *  Questo metodo non fa altro che controllare che i thread che sono 
 *  presenti nella lista siano tutti thread attivi.
 *********************************************************************/
public void checkAlive() 
{
	Enumeration ee = list.elements();
	Enumeration ek = list.keys();

	for(;ee.hasMoreElements();) {
		Thread RT = (Thread) ee.nextElement();
		AgentIdentity AI = (AgentIdentity) ek.nextElement();
		if (RT.isAlive()) {
			Printer.print_out(pout, RT.toString());
		} 
		else {
			// rimuovo dalla lista dei thread l'item
			// se il processo corrispondente e' gia'
			// terminato
			list.remove(AI);
	  	}
	}
}
  
/**********************************************************************
 *  Questo metodo lancia in esecuzione un thread reattivo. Gli vengono
 *  passati come parametri l'identita' dell'agente I che esegue le operazioni,
 *  un riferimento allo spazio di tuple S, la reazione O e un vettore
 *  contenente i risultati della azione della operazione.
 *********************************************************************/

public Entry Launch(ReactiveThread RT, Entry E, Space S, Principal I, 
		Entry[] array, Entry pass) 
{
	/************************************************************************
	 *		decrizione dei parametri
	 *il primo parametro rappresenta l'identificatore del thread da lanciare
	 *il secondo, il terzo ed il quarto vanno passati alla InitAndReturn e
	 *in pratica descrivono l'operazione che ha provocato la reazione
	 *l'array serve a ??
	 *pass serve a ???
	 *************************************************************************/

	//Printer.print_out(pout, "ReactionManager: I start the reaction: " + 
	//	RT.getClass().toString() + (RT.getClass().getSuperclass()).toString());
	//RT.item_array(array);

		// genero un Thread a partire da quell'oggetto

	Thread rthread = null;
	try { 
		//AccessController.beginPrivileged();
		rthread = new Thread(Tgroup, RT);
	} 
	finally {
		//AccessController.endPrivileged(); 
	}
	// memorizzo nella lista l'identita' dell'agente e il thread che
	// ha mandato in esecuzione.
	
	list.put(I.getName(), rthread);

		// chiamo il metodo che mi consente di ritornare
		// informazioni al metodo di space che lancia le 
		// reazione (come per esempio che deve essere ritornato
		// null)
	
	Entry[] ris = RT.InitAndReturn(E, S, I);	

		// mando in esecuzione il thread reattivo
	try {
		//AccessController.beginPrivileged();
		rthread.start();
	} finally {
		//AccessController.endPrivileged();
	}

	return ris[0];
}


}

