package jive.javaSpace;

/**********************************************************************
 *  Questa classe costituisce la classe di appartenenza delle entry
 *  dello spazio di reazioni. Queste sono costituite dalla sequenza di:
 * (Tipo_di_Operazione, Tipo_di_Entry, Identita'_agente, ThreadReattivo)
 *
 *********************************************************************/

import jive.reactive_class.*;
import jive.security.*;
import java.security.*;
import java.util.*;
import jive.util.*;
import jive.security.AclImpl;
import java.security.acl.Acl;

public class ReactionEntry implements Entry, Comparable
{
	public Entry entry;
	public Principal identity;
	public String operation;
	public ReactiveThread reaction;
	public AclImpl acl = null;
	Date date = new Date();
	
public ReactionEntry() 
{
	identity = null;
}

public ReactionEntry (Entry E,  Principal I, String O,ReactiveThread T) 
{
	entry = E;
	identity = I;
      operation = O;
	reaction = T;
}

public Entry getEntry() 
{
	return entry;
}

public Principal getIdentity() 
{
	return identity;
}

public String getOperation() 
{
	return operation;
}
	
public ReactiveThread getReaction() 
{
	return reaction;
}

public Acl getAcl()
{
	 return acl;
}  

public void setAcl(Acl a) 
{
	if ( acl == null ) acl = (AclImpl) a;
}  

public Date getDate() 
{
	return date;
}
 
public int compareTo(Date data1, Date data2) 
{
	long firstTime = data1.getTime();
	long secondTime = data2.getTime();
	return (firstTime < secondTime ? -1: (firstTime == secondTime ? 0:1));
}

public int compareTo (Object re ) 
{
	ReactionEntry rer = (ReactionEntry)re;
	return (compareTo((Date)this.getDate(), (Date)rer.getDate()));
}

//public setDate() {
//Date = System.currentMillis();
//}

/*public String toString() {
		
		// da notare che la classe della reazione non puo' essere
		// nulla, mentre l'identita', il tipo di operazione e 
		// la entry si.
		String tmp1 = null;
		String tmp2 = "null";
		if (entry != null) {
			tmp1 = entry.getClass().toString();
			tmp2 = tmp1.substring(tmp1.lastIndexOf(".")+1);
		}
		String tmp3 =((Object)reaction).toString();
		String tmp4 = "null";
		String tmp5 = date.toString();
		if (identity != null) tmp4 = identity.getName();
		String ris = " Id: "+tmp4+"  "+
		"Op: "+operation+"  "+"Entry: "+tmp2+
		" "+"Reaction: "+tmp3.substring(tmp3.lastIndexOf(".")+1);
		return ris;

}*/

public void showValues() 
{
	//System.out.println("	4-pla reattiva: la mia entry vale: ");
	entry.showValues();
	System.out.println("	4-pla: altri campi: "+identity+" "+operation+" "+reaction);
	System.out.println("	4-pla: data "+date);
}
}