package jive.javaSpace;

/**********************************************************************
 * Questa classe costituisce la classe superclasse di tutte le classi
 * che rappresentano reazioni.
 *********************************************************************/

import java.security.*;
import jive.security.*;

public abstract class ReactiveThread implements Runnable, 
						 java.io.Serializable {

public ReactiveThread() {}
  
  // Questo campo viene assegnato nel momento in cui
  // viene scatenata la reazione, e vengono memorizzati
  // dati diversi a seconda del tipo di reazione:
  // * nel caso di reazione pre-action non conterra' alcun
  //   valore.
  // * nel caso di reazione infra-action conterra' l'ultimo
  //   elemento selezionato (nel caso di read o take) o 
  //   l'elemento scritto nello spazio nel caso di write.
  // * nel caso di reazione post-action il campo conterra'
  //   il o gli elementi selezionati (dopo che sono stati
  //   eventualmente modificati dalla reazione).
  
  // imporre che il valore di ritorno debba essere un'array
  // di Entry ci consente di evitare controlli sul tipo dei 
  // dati effettivamente restituiti dalla reazione. 
  protected Entry[] item_array = null;
  
  public abstract Entry[] InitAndReturn
  (Entry tuple, Space space, Principal who);  

  public final void item_array(Entry[] array) {
	 // if (item_array == null) 
	 item_array = array;
  }  
  public void run() {}  
}