package jive.javaSpace;

/* ****************************************************************
   * Questa classe  quella degli oggetti-interfaccia che ogni agente
   * ottiene per accedere allo spazio. I controlli di accesso sul 
   * tuple space, si effettuano a questo livello.
   ****************************************************************/

import jive.security.*;
import java.security.*;
import java.util.*;
import jive.util.*;
import jive.util.Passer;
import jive.tuple_type.*;
import net.jini.core.event.*;
import net.jini.core.lease.*;
import java.rmi.*;
import java.security.acl.*;

public class Space implements MARS
{

	public Principal  myId;
	private Passer pout = null;
	public MARSInt sp;
  

public Space (Principal id, Passer Pout) 
{
	myId = id;
	pout = Pout;
}

public Space(Principal id,Passer Pout , MARSInt space) 
{
	myId = id;
	pout = Pout;
	sp = space;
}  
 
public Entry read (Entry entry, Transaction txn, long timeout) 
		throws NotInterfaceOwnerException,NoPermissionException
{
	// (!sp.checkPermission(myId, new PermissionImpl("READ")) )
	//	throw new NoPermissionException();
	return sp.read(entry, txn, timeout, myId);
}
 
 
public  Entry[] readAll (Entry entry, Transaction txn,long timeout)
		throws NotInterfaceOwnerException,NoPermissionException 
{
	//if (!sp.checkPermission(myId, new PermissionImpl("READ")) )
	//	throw new NoPermissionException();
	return sp.readAll(entry, txn, timeout, myId);
}  
 
 
public Entry take (Entry entry, Transaction txn, long timeout)
		throws NotInterfaceOwnerException,NoPermissionException
{
	//if (!sp.checkPermission(myId, new PermissionImpl("TAKE")) )
	//	throw new NoPermissionException();
	return sp.take(entry, txn, timeout, myId);
}
 
 
public  Entry[] takeAll (Entry entry, Transaction txn,long timeout)
		throws NotInterfaceOwnerException,NoPermissionException
{
	//if (!sp.checkPermission(myId, new PermissionImpl("TAKE")) )
	//	throw new NoPermissionException();
	return sp.takeAll(entry, txn, timeout, myId);
}
 
  
public Lease write(Entry entry, Transaction txn, long lease) 
	throws NotInterfaceOwnerException, NoPermissionException
{
	//if (!sp.checkPermission(myId, new PermissionImpl("WRITE")) )
	//	throw new NoPermissionException();
	return sp.write(entry, txn, lease, myId);
}

  
Principal getIdentity() 
{
	return this.myId;
}
 

public void print(String msg) 
{
	Date now = new Date();
	String prefix ="("+now.getHours()+":"+now.getMinutes()+":"+
		now.getSeconds()+") "+myId.getName()+": ";

	if (pout == null)
		System.out.println(prefix+msg);
	else
		pout.put(prefix+msg);
} 


public EventRegistration notify (Entry tmpl, Transaction tr, RemoteEventListener
	listener, long leaseTime, Object handback) 
	throws  RemoteException 
{
	//if (!sp.checkPermission(myId, new PermissionImpl("NOTIFY")) )
	//	throw new NoPermissionException();

	return sp.notify(tmpl, tr, listener, leaseTime, handback);
}
 
}