package jive.javaSpace;

/*************************************************************************
 *  Questa classe rappresenta il class server dello spazio.
 *  Il class server ha il compito di memorizzare le classi delle entry 
 *  presenti nello spazio assieme alle loro superclassi. Ognuna di tali 
 *  classi e' individuata da una chiave che non e' altro che il SUID della
 *  classe. La classe viene memorizzata come una struttura di due campi:
 *  - nome della classe (String).
 *  - forma serializzata della classe (byte[]).
 *  I metodi permettono di aggiungere e recuperare una classe memorizzata.
 *************************************************************************/

import java.util.*;

public class SpaceClassServer {

  class struct {
	String name;
	byte[] data;
	
	struct (String n, byte[] d) {
	  name = n;
	  data = d;
	}
  }
  private Hashtable cache;
  
  public SpaceClassServer() {
	cache = new Hashtable();
  }  
  public void addClass(long s, String n, byte[] d) {
	if (!cache.containsKey(new Long(s)))
	  cache.put(new Long(s), (Object)(new struct(n, d)));

  }  
  public byte[] getClass(long s) {
	return ((struct)cache.get(new Long(s))).data;
  }  
  public String getName(long s) {
	return ((struct)cache.get(new Long(s))).name;
  }  
}