package jive.tuple_type;

import jive.remote.*;
import jive.javaSpace.*;
import jive.security.*;
import java.security.*;
import java.security.Principal;
import java.rmi.RemoteException;
public class SpaceTuple extends Entry {
	public SpaceIdentity space = null;
	public String keyword = null;
	public String description = null;
	public Integer hash = null;
	public Boolean remote = null;
	private SpaceKernel kernel = null;
	private RemoteSpaceKernel remotekernel = null;
public SpaceTuple() {
}
public SpaceTuple(SpaceKernel sk) {
	kernel = sk;
	remote = new Boolean(false);
	hash = new Integer(kernel.hashCode());
}
  public SpaceTuple(RemoteSpaceKernel rsk) {
  
	 remotekernel = rsk;
	 remote = new Boolean(true);
	 hash = new Integer(remotekernel.hashCode());
   }   
  public SpaceTuple(SpaceTuple old) {
  
	space = old.space;
	keyword = old.keyword;
	description = old.description;
	hash = old.hash;
	remote = old.remote;
	kernel = old.kernel;
	remotekernel = old.remotekernel;
	
  }  
  public void localize() {
  
	if (remotekernel != null) {
	   try {
			 kernel = remotekernel.getLocal();
			 remotekernel = null;
			 remote = new Boolean(false);
			 hash = new Integer(kernel.hashCode());
	   } catch(RemoteException e) {
		  e.printStackTrace();
		  kernel = null;   
	   }
	}
  }  
public Space passive(Principal who) throws /*AccessControlException,*/ NoPermissionException {
	//AccessController.checkPermission(new MARSRolePermission(who.getName()/));
	Space passive = null;
	if (remote != null)
		if (remote.booleanValue() && remotekernel != null) {
			RemoteSpace remotepassive = null;
			try {
				remotepassive = remotekernel.createPassiveSpace(who);
			} catch (RemoteException e) {
				e.printStackTrace();
			}
			if (remotepassive != null)
				passive = new ClientSpace(remotepassive);
		} else
			if (!remote.booleanValue() && kernel != null) {
				passive = kernel.createPassiveSpace(who);
			}
	return passive;
}
public Space reactive(Principal who) throws /*AccessControlException,*/ NoPermissionException {
	//AccessController.checkPermission(new MARSRolePermission(who.getName()));
	Space reactive = null;
	if (remote != null)
		if (remote.booleanValue() && remotekernel != null) {
			RemoteSpace remotereactive = null;
			try {
				remotereactive = remotekernel.createReactiveSpace(who);
			} catch (RemoteException e) {
				e.printStackTrace();
			}
			if (remotereactive != null)
				reactive = new ClientSpace(remotereactive);
		} else
			if (!remote.booleanValue() && kernel != null) {
				reactive = kernel.createReactiveSpace(who);
			}
	return reactive;
}
public void remotize() {
	if (kernel != null) {
		try {
			remotekernel = new RemoteSpaceKernelImpl(kernel);
			kernel = null;
			remote = new Boolean(true);
			hash = new Integer(remotekernel.hashCode());
		} catch (RemoteException e) {
			e.printStackTrace();
			remotekernel = null;
		}
	}
}
}