/*
 * Copyright 1999 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * The contents of this file are subject to the Sun(TM) Community Source
 * License, Jini(TM) Technology Core Platform, v. 1.0 (the "License"); 
 * you may not use this file except in compliance with the License. You 
 * may obtain a copy of the License at http://www.sun.com/jini. Software
 * distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the  
 * License for the specific language governing rights and limitations
 * under the License.
 * 
 * The Original Code is Jini Technology Core Platform code, version 1.0.
 * The Developer of the Original Code is Sun Microsystems, Inc. Portions
 * created by Sun Microsystems, Inc. are Copyright (C) 1999 Sun
 * Microsystems, Inc. All Rights Reserved.
 * 
 * Contributor(s): Sun Microsystems, Inc.
 * 
 * CopyrightVersion 1.0.1_JCP 
 */
package net.jini.core.event;

/**
 * An exception thrown when the recipient of a RemoteEvent does not recognize
 * the combination of the event identifier and the event source as something
 * in which it is interested.  Throwing this exception has the effect of
 * asking the sender to not send further notifications of this kind of event
 * from this source in the future.
 */

public class UnknownEventException extends Exception
{
    private static final long serialVersionUID = 5563758083292687048L;

    /**
     * Constructs an UnknownEventException with the specified detail message.
     */
    public UnknownEventException(String reason) 
    {
	super(reason);
    }

    /**
     * Constructs an UnknownEventException with no detail message.
     */
    public UnknownEventException()
    {
	super();
    }
}
