/*
 * Copyright 1999 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * The contents of this file are subject to the Sun(TM) Community Source
 * License, Jini(TM) Technology Core Platform, v. 1.0 (the "License"); 
 * you may not use this file except in compliance with the License. You 
 * may obtain a copy of the License at http://www.sun.com/jini. Software
 * distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the  
 * License for the specific language governing rights and limitations
 * under the License.
 * 
 * The Original Code is Jini Technology Core Platform code, version 1.0.
 * The Developer of the Original Code is Sun Microsystems, Inc. Portions
 * created by Sun Microsystems, Inc. are Copyright (C) 1999 Sun
 * Microsystems, Inc. All Rights Reserved.
 * 
 * Contributor(s): Sun Microsystems, Inc.
 * 
 * CopyrightVersion 1.0.1_JCP 
 */
package net.jini.core.transaction.server;

import net.jini.core.transaction.*;


/**
 * Exception thrown when a transaction cannot be joined because the
 * participant's current crash count is different from the crash
 * count the manager received in a previous join by that participant.
 *
 * @see TransactionManager#join
 * @see ServerTransaction#join
 */
public class CrashCountException extends TransactionException {
    static final long serialVersionUID = 4299226125245015671L;

    /**
     * Constructs an instance with a detail message.
     *
     * @param reason the detail message
     */
    public CrashCountException (String reason) {
	super(reason);
    }

    /** Constructs an instance with no detail message. */
    public CrashCountException() {
	super();
    }
}
