/*
 * Copyright 1999 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * The contents of this file are subject to the Sun(TM) Community Source
 * License, Jini(TM) Technology Core Platform, v. 1.0 (the "License"); 
 * you may not use this file except in compliance with the License. You 
 * may obtain a copy of the License at http://www.sun.com/jini. Software
 * distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the  
 * License for the specific language governing rights and limitations
 * under the License.
 * 
 * The Original Code is Jini Technology Core Platform code, version 1.0.
 * The Developer of the Original Code is Sun Microsystems, Inc. Portions
 * created by Sun Microsystems, Inc. are Copyright (C) 1999 Sun
 * Microsystems, Inc. All Rights Reserved.
 * 
 * Contributor(s): Sun Microsystems, Inc.
 * 
 * CopyrightVersion 1.0.1_JCP 
 */
package net.jini.core.transaction.server;

/** Constants common to transaction managers and participants. */
public interface TransactionConstants {
    /** Transaction is currently active */
    final int ACTIVE = 1;
    /** Transaction is determining if it can be committed */
    final int VOTING = 2;
    /** Transaction has been prepared but not yet committed */
    final int PREPARED = 3;
    /** Transaction has been prepared with nothing to commit */
    final int NOTCHANGED = 4;
    /** Transaction has been committed */
    final int COMMITTED = 5;
    /** Transaction has been aborted */
    final int ABORTED = 6;
}
