/*
 * Copyright 1999 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * The contents of this file are subject to the Sun(TM) Community Source
 * License, Jini(TM) Technology Core Platform, v. 1.0 (the "License");
 * you may not use this file except in compliance with the License. You
 * may obtain a copy of the License at http://www.sun.com/jini. Software
 * distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
 * License for the specific language governing rights and limitations
 * under the License.
 * 
 * The Original Code is Jini Technology Core Platform code, version 1.0.
 * The Developer of the Original Code is Sun Microsystems, Inc. Portions
 * created by Sun Microsystems, Inc. are Copyright (C) 1999 Sun
 * Microsystems, Inc. All Rights Reserved.
 * 
 * Contributor(s): Sun Microsystems, Inc.
 * 
 * The contents of this file comply with the Jini Technology
 * Core Platform Compatibility Kit Version 1.0B
 * 
 * Tester(s): Sun Microsystems, Inc.
 * 
 * Test Platform(s): Java(TM) 2 SDK v1.2.2 Solaris(TM) Reference
 *                   Implementation (Final) on Solaris 2.6
 * 
 *                   Java 2 SDK v1.2.2 Microsoft Windows 95/98/NT
 *                   Production Release (Final) on Microsoft Windows
 *                   NT 4.0 SP4
 * 
 * CopyrightVersion 1.0.1_JXP
 */
package net.jini.lookup.entry;

import net.jini.entry.AbstractEntry;
import java.awt.Image;

/**
 * Human-oriented information about the "type" of a service.  This is
 * not related to its data or class types, and is more oriented towards
 * allowing someone to determine what a service (for example, a printer)
 * does and that it is similar to another, without needing to know
 * anything about data or class types for the Java platform.
 *
 * @author Bryan O'Sullivan
 */
public abstract class ServiceType extends AbstractEntry
				  implements ServiceControlled
{
    private static final long serialVersionUID = -6443809721367395836L;

    /**
     * Instantiate this class.
     */
    public ServiceType() {
    }

    /**
     * Get an icon for this service.  This icon may be localized where
     * appropriate.  The valid parameter values are the same as for
     * the getIcon method of java.beans.BeanInfo.
     *
     * @param iconKind the kind of icon to return
     */
    public Image getIcon(int iconKind) {
	return null;
    }

    /**
     * Return the localized display name of this service.
     */
    public String getDisplayName() {
	return null;
    }

    /**
     * Return a localized short description of this service.
     */
    public String getShortDescription() {
	return null;
    }
}
